#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TAxis__
#define __HROOT_HIST__TAxis__

#include "HROOT-histType.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttAxis.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef TAXIS_DECL_VIRT 
#define TAXIS_DECL_VIRT(Type) \
int Type ## _findBinTAxis ( Type ## _p p, double x ); \
int Type ## _findFixBinTAxis ( Type ## _p p, double x ); \
double Type ## _getBinCenterTAxis ( Type ## _p p, int bin ); \
double Type ## _GetBinCenterLog ( Type ## _p p, int bin ); \
double Type ## _GetBinUpEdge ( Type ## _p p, int bin ); \
void Type ## _SetTimeDisplay ( Type ## _p p, int value ); \
void Type ## _SetTimeFormat ( Type ## _p p, const char* format ); \
void Type ## _SetTimeOffset ( Type ## _p p, double toffset, const char* option )

#undef TAXIS_DECL_NONVIRT 
#define TAXIS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAxis ( int nbins, double xmin, double xmax ); \
int Type ## _tAxisGetCenterLabels ( Type ## _p p ); \
int Type ## _tAxisGetCenterTitle ( Type ## _p p )

#undef TAXIS_DEF_VIRT
#define TAXIS_DEF_VIRT(Type)\
int Type ## _findBinTAxis ( Type ## _p p, double x )\
{\
return TYPECASTMETHOD(Type,findBinTAxis,TAxis)(p)->FindBin(x);\
}\
int Type ## _findFixBinTAxis ( Type ## _p p, double x )\
{\
return TYPECASTMETHOD(Type,findFixBinTAxis,TAxis)(p)->FindFixBin(x);\
}\
double Type ## _getBinCenterTAxis ( Type ## _p p, int bin )\
{\
return TYPECASTMETHOD(Type,getBinCenterTAxis,TAxis)(p)->GetBinCenter(bin);\
}\
double Type ## _GetBinCenterLog ( Type ## _p p, int bin )\
{\
return TYPECASTMETHOD(Type,GetBinCenterLog,TAxis)(p)->GetBinCenterLog(bin);\
}\
double Type ## _GetBinUpEdge ( Type ## _p p, int bin )\
{\
return TYPECASTMETHOD(Type,GetBinUpEdge,TAxis)(p)->GetBinUpEdge(bin);\
}\
void Type ## _SetTimeDisplay ( Type ## _p p, int value )\
{\
TYPECASTMETHOD(Type,SetTimeDisplay,TAxis)(p)->SetTimeDisplay(value);\
}\
void Type ## _SetTimeFormat ( Type ## _p p, const char* format )\
{\
TYPECASTMETHOD(Type,SetTimeFormat,TAxis)(p)->SetTimeFormat(format);\
}\
void Type ## _SetTimeOffset ( Type ## _p p, double toffset, const char* option )\
{\
TYPECASTMETHOD(Type,SetTimeOffset,TAxis)(p)->SetTimeOffset(toffset, option);\
}

#undef TAXIS_DEF_NONVIRT
#define TAXIS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAxis ( int nbins, double xmin, double xmax )\
{\
Type * newp = new Type (nbins, xmin, xmax); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int Type ## _tAxisGetCenterLabels ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAxisGetCenterLabels,TAxis)(p)->GetCenterLabels();\
}\
int Type ## _tAxisGetCenterTitle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAxisGetCenterTitle,TAxis)(p)->GetCenterTitle();\
}

TNAMED_DECL_VIRT(TAxis);
TATTAXIS_DECL_VIRT(TAxis);
TOBJECT_DECL_VIRT(TAxis);
DELETABLE_DECL_VIRT(TAxis);


TAXIS_DECL_VIRT(TAxis);


TAXIS_DECL_NONVIRT(TAxis);


#endif // __HROOT_HIST__TAxis__

#ifdef __cplusplus
}
#endif

