{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Hist.TGraphAsymmErrors.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Hist.TGraphAsymmErrors.RawType
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TAxis.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Apply"
               c_tgraphasymmerrors_apply ::
               Ptr RawTGraphAsymmErrors -> Ptr RawTF1 -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Chisquare"
               c_tgraphasymmerrors_chisquare ::
               Ptr RawTGraphAsymmErrors -> Ptr RawTF1 -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_DrawGraph"
               c_tgraphasymmerrors_drawgraph ::
               Ptr RawTGraphAsymmErrors ->
                 CInt -> (Ptr CDouble) -> (Ptr CDouble) -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_drawPanelTGraph"
               c_tgraphasymmerrors_drawpaneltgraph ::
               Ptr RawTGraphAsymmErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Expand"
               c_tgraphasymmerrors_expand ::
               Ptr RawTGraphAsymmErrors -> CInt -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_FitPanelTGraph"
               c_tgraphasymmerrors_fitpaneltgraph ::
               Ptr RawTGraphAsymmErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_getCorrelationFactorTGraph"
               c_tgraphasymmerrors_getcorrelationfactortgraph ::
               Ptr RawTGraphAsymmErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_getCovarianceTGraph"
               c_tgraphasymmerrors_getcovariancetgraph ::
               Ptr RawTGraphAsymmErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_getMeanTGraph"
               c_tgraphasymmerrors_getmeantgraph ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_getRMSTGraph"
               c_tgraphasymmerrors_getrmstgraph ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorX"
               c_tgraphasymmerrors_geterrorx ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorY"
               c_tgraphasymmerrors_geterrory ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorXhigh"
               c_tgraphasymmerrors_geterrorxhigh ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorXlow"
               c_tgraphasymmerrors_geterrorxlow ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorYhigh"
               c_tgraphasymmerrors_geterroryhigh ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorYlow"
               c_tgraphasymmerrors_geterrorylow ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_InitExpo"
               c_tgraphasymmerrors_initexpo ::
               Ptr RawTGraphAsymmErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_InitGaus"
               c_tgraphasymmerrors_initgaus ::
               Ptr RawTGraphAsymmErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_InitPolynom"
               c_tgraphasymmerrors_initpolynom ::
               Ptr RawTGraphAsymmErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_InsertPoint"
               c_tgraphasymmerrors_insertpoint ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_integralTGraph"
               c_tgraphasymmerrors_integraltgraph ::
               Ptr RawTGraphAsymmErrors -> CInt -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_IsEditable"
               c_tgraphasymmerrors_iseditable ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_isInsideTGraph"
               c_tgraphasymmerrors_isinsidetgraph ::
               Ptr RawTGraphAsymmErrors -> CDouble -> CDouble -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_LeastSquareFit"
               c_tgraphasymmerrors_leastsquarefit ::
               Ptr RawTGraphAsymmErrors ->
                 CInt -> (Ptr CDouble) -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_PaintStats"
               c_tgraphasymmerrors_paintstats ::
               Ptr RawTGraphAsymmErrors -> Ptr RawTF1 -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_RemovePoint"
               c_tgraphasymmerrors_removepoint ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetEditable"
               c_tgraphasymmerrors_seteditable ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetHistogram"
               c_tgraphasymmerrors_sethistogram ::
               Ptr RawTGraphAsymmErrors -> Ptr RawTH1F -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_setMaximumTGraph"
               c_tgraphasymmerrors_setmaximumtgraph ::
               Ptr RawTGraphAsymmErrors -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_setMinimumTGraph"
               c_tgraphasymmerrors_setminimumtgraph ::
               Ptr RawTGraphAsymmErrors -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Set"
               c_tgraphasymmerrors_set ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetPoint"
               c_tgraphasymmerrors_setpoint ::
               Ptr RawTGraphAsymmErrors -> CInt -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetName"
               c_tgraphasymmerrors_setname ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetNameTitle"
               c_tgraphasymmerrors_setnametitle ::
               Ptr RawTGraphAsymmErrors -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetTitle"
               c_tgraphasymmerrors_settitle ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetLineColor"
               c_tgraphasymmerrors_getlinecolor ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetLineStyle"
               c_tgraphasymmerrors_getlinestyle ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetLineWidth"
               c_tgraphasymmerrors_getlinewidth ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_ResetAttLine"
               c_tgraphasymmerrors_resetattline ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetLineAttributes"
               c_tgraphasymmerrors_setlineattributes ::
               Ptr RawTGraphAsymmErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetLineColor"
               c_tgraphasymmerrors_setlinecolor ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetLineStyle"
               c_tgraphasymmerrors_setlinestyle ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetLineWidth"
               c_tgraphasymmerrors_setlinewidth ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetFillColor"
               c_tgraphasymmerrors_setfillcolor ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetFillStyle"
               c_tgraphasymmerrors_setfillstyle ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerColor"
               c_tgraphasymmerrors_getmarkercolor ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerStyle"
               c_tgraphasymmerrors_getmarkerstyle ::
               Ptr RawTGraphAsymmErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerSize"
               c_tgraphasymmerrors_getmarkersize ::
               Ptr RawTGraphAsymmErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_ResetAttMarker"
               c_tgraphasymmerrors_resetattmarker ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerAttributes"
               c_tgraphasymmerrors_setmarkerattributes ::
               Ptr RawTGraphAsymmErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerColor"
               c_tgraphasymmerrors_setmarkercolor ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerStyle"
               c_tgraphasymmerrors_setmarkerstyle ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerSize"
               c_tgraphasymmerrors_setmarkersize ::
               Ptr RawTGraphAsymmErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Draw"
               c_tgraphasymmerrors_draw ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_FindObject"
               c_tgraphasymmerrors_findobject ::
               Ptr RawTGraphAsymmErrors -> CString -> IO (Ptr RawTObject)

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_GetName"
               c_tgraphasymmerrors_getname ::
               Ptr RawTGraphAsymmErrors -> IO CString

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_IsA"
               c_tgraphasymmerrors_isa ::
               Ptr RawTGraphAsymmErrors -> IO (Ptr RawTClass)

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Paint"
               c_tgraphasymmerrors_paint ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_printObj"
               c_tgraphasymmerrors_printobj ::
               Ptr RawTGraphAsymmErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_SaveAs"
               c_tgraphasymmerrors_saveas ::
               Ptr RawTGraphAsymmErrors -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_Write"
               c_tgraphasymmerrors_write ::
               Ptr RawTGraphAsymmErrors -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_delete"
               c_tgraphasymmerrors_delete :: Ptr RawTGraphAsymmErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphAsymmErrors.h TGraphAsymmErrors_newTGraphAsymmErrors"
               c_tgraphasymmerrors_newtgraphasymmerrors ::
               CInt ->
                 (Ptr CDouble) ->
                   (Ptr CDouble) ->
                     (Ptr CDouble) ->
                       (Ptr CDouble) ->
                         (Ptr CDouble) -> (Ptr CDouble) -> IO (Ptr RawTGraphAsymmErrors)
