{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TGraphAsymmErrors.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TGraphAsymmErrors.RawType
import HROOT.Hist.TGraphAsymmErrors.FFI
import HROOT.Hist.TGraphAsymmErrors.Interface
import HROOT.Hist.TGraphAsymmErrors.Cast
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1F.Cast
import HROOT.Hist.TH1F.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TGraph.RawType
import HROOT.Hist.TGraph.Cast
import HROOT.Hist.TGraph.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITGraphAsymmErrors TGraphAsymmErrors

instance ITGraph TGraphAsymmErrors where
        apply = xform1 c_tgraphasymmerrors_apply
        chisquare = xform1 c_tgraphasymmerrors_chisquare
        drawGraph = xform4 c_tgraphasymmerrors_drawgraph
        drawPanelTGraph = xform0 c_tgraphasymmerrors_drawpaneltgraph
        expand = xform2 c_tgraphasymmerrors_expand
        fitPanelTGraph = xform0 c_tgraphasymmerrors_fitpaneltgraph
        getCorrelationFactorTGraph
          = xform0 c_tgraphasymmerrors_getcorrelationfactortgraph
        getCovarianceTGraph
          = xform0 c_tgraphasymmerrors_getcovariancetgraph
        getMeanTGraph = xform1 c_tgraphasymmerrors_getmeantgraph
        getRMSTGraph = xform1 c_tgraphasymmerrors_getrmstgraph
        getErrorX = xform1 c_tgraphasymmerrors_geterrorx
        getErrorY = xform1 c_tgraphasymmerrors_geterrory
        getErrorXhigh = xform1 c_tgraphasymmerrors_geterrorxhigh
        getErrorXlow = xform1 c_tgraphasymmerrors_geterrorxlow
        getErrorYhigh = xform1 c_tgraphasymmerrors_geterroryhigh
        getErrorYlow = xform1 c_tgraphasymmerrors_geterrorylow
        initExpo = xform2 c_tgraphasymmerrors_initexpo
        initGaus = xform2 c_tgraphasymmerrors_initgaus
        initPolynom = xform2 c_tgraphasymmerrors_initpolynom
        insertPoint = xform0 c_tgraphasymmerrors_insertpoint
        integralTGraph = xform2 c_tgraphasymmerrors_integraltgraph
        isEditable = xform0 c_tgraphasymmerrors_iseditable
        isInsideTGraph = xform2 c_tgraphasymmerrors_isinsidetgraph
        leastSquareFit = xform4 c_tgraphasymmerrors_leastsquarefit
        paintStats = xform1 c_tgraphasymmerrors_paintstats
        removePoint = xform1 c_tgraphasymmerrors_removepoint
        setEditable = xform1 c_tgraphasymmerrors_seteditable
        setHistogram = xform1 c_tgraphasymmerrors_sethistogram
        setMaximumTGraph = xform1 c_tgraphasymmerrors_setmaximumtgraph
        setMinimumTGraph = xform1 c_tgraphasymmerrors_setminimumtgraph
        set = xform1 c_tgraphasymmerrors_set
        setPoint = xform3 c_tgraphasymmerrors_setpoint

instance ITNamed TGraphAsymmErrors where
        setName = xform1 c_tgraphasymmerrors_setname
        setNameTitle = xform2 c_tgraphasymmerrors_setnametitle
        setTitle = xform1 c_tgraphasymmerrors_settitle

instance ITAttLine TGraphAsymmErrors where
        getLineColor = xform0 c_tgraphasymmerrors_getlinecolor
        getLineStyle = xform0 c_tgraphasymmerrors_getlinestyle
        getLineWidth = xform0 c_tgraphasymmerrors_getlinewidth
        resetAttLine = xform1 c_tgraphasymmerrors_resetattline
        setLineAttributes = xform0 c_tgraphasymmerrors_setlineattributes
        setLineColor = xform1 c_tgraphasymmerrors_setlinecolor
        setLineStyle = xform1 c_tgraphasymmerrors_setlinestyle
        setLineWidth = xform1 c_tgraphasymmerrors_setlinewidth

instance ITAttFill TGraphAsymmErrors where
        setFillColor = xform1 c_tgraphasymmerrors_setfillcolor
        setFillStyle = xform1 c_tgraphasymmerrors_setfillstyle

instance ITAttMarker TGraphAsymmErrors where
        getMarkerColor = xform0 c_tgraphasymmerrors_getmarkercolor
        getMarkerStyle = xform0 c_tgraphasymmerrors_getmarkerstyle
        getMarkerSize = xform0 c_tgraphasymmerrors_getmarkersize
        resetAttMarker = xform1 c_tgraphasymmerrors_resetattmarker
        setMarkerAttributes
          = xform0 c_tgraphasymmerrors_setmarkerattributes
        setMarkerColor = xform1 c_tgraphasymmerrors_setmarkercolor
        setMarkerStyle = xform1 c_tgraphasymmerrors_setmarkerstyle
        setMarkerSize = xform1 c_tgraphasymmerrors_setmarkersize

instance ITObject TGraphAsymmErrors where
        draw = xform1 c_tgraphasymmerrors_draw
        findObject = xform1 c_tgraphasymmerrors_findobject
        getName = xform0 c_tgraphasymmerrors_getname
        isA = xform0 c_tgraphasymmerrors_isa
        paint = xform1 c_tgraphasymmerrors_paint
        printObj = xform1 c_tgraphasymmerrors_printobj
        saveAs = xform2 c_tgraphasymmerrors_saveas
        write = xform3 c_tgraphasymmerrors_write

instance IDeletable TGraphAsymmErrors where
        delete = xform0 c_tgraphasymmerrors_delete

newTGraphAsymmErrors ::
                       CInt ->
                         (Ptr CDouble) ->
                           (Ptr CDouble) ->
                             (Ptr CDouble) ->
                               (Ptr CDouble) ->
                                 (Ptr CDouble) -> (Ptr CDouble) -> IO TGraphAsymmErrors
newTGraphAsymmErrors
  = xform6 c_tgraphasymmerrors_newtgraphasymmerrors
