{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Hist.TGraphErrors.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Hist.TGraphErrors.RawType
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TAxis.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Apply" c_tgrapherrors_apply
               :: Ptr RawTGraphErrors -> Ptr RawTF1 -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Chisquare"
               c_tgrapherrors_chisquare ::
               Ptr RawTGraphErrors -> Ptr RawTF1 -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_DrawGraph"
               c_tgrapherrors_drawgraph ::
               Ptr RawTGraphErrors ->
                 CInt -> (Ptr CDouble) -> (Ptr CDouble) -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_drawPanelTGraph"
               c_tgrapherrors_drawpaneltgraph :: Ptr RawTGraphErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Expand" c_tgrapherrors_expand
               :: Ptr RawTGraphErrors -> CInt -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_FitPanelTGraph"
               c_tgrapherrors_fitpaneltgraph :: Ptr RawTGraphErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_getCorrelationFactorTGraph"
               c_tgrapherrors_getcorrelationfactortgraph ::
               Ptr RawTGraphErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_getCovarianceTGraph"
               c_tgrapherrors_getcovariancetgraph ::
               Ptr RawTGraphErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_getMeanTGraph"
               c_tgrapherrors_getmeantgraph ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_getRMSTGraph"
               c_tgrapherrors_getrmstgraph ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorX"
               c_tgrapherrors_geterrorx ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorY"
               c_tgrapherrors_geterrory ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorXhigh"
               c_tgrapherrors_geterrorxhigh ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorXlow"
               c_tgrapherrors_geterrorxlow ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorYhigh"
               c_tgrapherrors_geterroryhigh ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetErrorYlow"
               c_tgrapherrors_geterrorylow ::
               Ptr RawTGraphErrors -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_InitExpo"
               c_tgrapherrors_initexpo ::
               Ptr RawTGraphErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_InitGaus"
               c_tgrapherrors_initgaus ::
               Ptr RawTGraphErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_InitPolynom"
               c_tgrapherrors_initpolynom ::
               Ptr RawTGraphErrors -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_InsertPoint"
               c_tgrapherrors_insertpoint :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_integralTGraph"
               c_tgrapherrors_integraltgraph ::
               Ptr RawTGraphErrors -> CInt -> CInt -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_IsEditable"
               c_tgrapherrors_iseditable :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_isInsideTGraph"
               c_tgrapherrors_isinsidetgraph ::
               Ptr RawTGraphErrors -> CDouble -> CDouble -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_LeastSquareFit"
               c_tgrapherrors_leastsquarefit ::
               Ptr RawTGraphErrors ->
                 CInt -> (Ptr CDouble) -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_PaintStats"
               c_tgrapherrors_paintstats ::
               Ptr RawTGraphErrors -> Ptr RawTF1 -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_RemovePoint"
               c_tgrapherrors_removepoint ::
               Ptr RawTGraphErrors -> CInt -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetEditable"
               c_tgrapherrors_seteditable :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetHistogram"
               c_tgrapherrors_sethistogram ::
               Ptr RawTGraphErrors -> Ptr RawTH1F -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_setMaximumTGraph"
               c_tgrapherrors_setmaximumtgraph ::
               Ptr RawTGraphErrors -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_setMinimumTGraph"
               c_tgrapherrors_setminimumtgraph ::
               Ptr RawTGraphErrors -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Set" c_tgrapherrors_set ::
               Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetPoint"
               c_tgrapherrors_setpoint ::
               Ptr RawTGraphErrors -> CInt -> CDouble -> CDouble -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetName"
               c_tgrapherrors_setname :: Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetNameTitle"
               c_tgrapherrors_setnametitle ::
               Ptr RawTGraphErrors -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetTitle"
               c_tgrapherrors_settitle :: Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetLineColor"
               c_tgrapherrors_getlinecolor :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetLineStyle"
               c_tgrapherrors_getlinestyle :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetLineWidth"
               c_tgrapherrors_getlinewidth :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_ResetAttLine"
               c_tgrapherrors_resetattline ::
               Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetLineAttributes"
               c_tgrapherrors_setlineattributes :: Ptr RawTGraphErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetLineColor"
               c_tgrapherrors_setlinecolor :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetLineStyle"
               c_tgrapherrors_setlinestyle :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetLineWidth"
               c_tgrapherrors_setlinewidth :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetFillColor"
               c_tgrapherrors_setfillcolor :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetFillStyle"
               c_tgrapherrors_setfillstyle :: Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetMarkerColor"
               c_tgrapherrors_getmarkercolor :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetMarkerStyle"
               c_tgrapherrors_getmarkerstyle :: Ptr RawTGraphErrors -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetMarkerSize"
               c_tgrapherrors_getmarkersize :: Ptr RawTGraphErrors -> IO CDouble

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_ResetAttMarker"
               c_tgrapherrors_resetattmarker ::
               Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetMarkerAttributes"
               c_tgrapherrors_setmarkerattributes :: Ptr RawTGraphErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetMarkerColor"
               c_tgrapherrors_setmarkercolor ::
               Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetMarkerStyle"
               c_tgrapherrors_setmarkerstyle ::
               Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SetMarkerSize"
               c_tgrapherrors_setmarkersize ::
               Ptr RawTGraphErrors -> CInt -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Draw" c_tgrapherrors_draw ::
               Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_FindObject"
               c_tgrapherrors_findobject ::
               Ptr RawTGraphErrors -> CString -> IO (Ptr RawTObject)

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_GetName"
               c_tgrapherrors_getname :: Ptr RawTGraphErrors -> IO CString

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_IsA" c_tgrapherrors_isa ::
               Ptr RawTGraphErrors -> IO (Ptr RawTClass)

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Paint" c_tgrapherrors_paint
               :: Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_printObj"
               c_tgrapherrors_printobj :: Ptr RawTGraphErrors -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_SaveAs" c_tgrapherrors_saveas
               :: Ptr RawTGraphErrors -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_Write" c_tgrapherrors_write
               :: Ptr RawTGraphErrors -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_delete" c_tgrapherrors_delete
               :: Ptr RawTGraphErrors -> IO ()

foreign import ccall safe
               "HROOTHistTGraphErrors.h TGraphErrors_newTGraphErrors"
               c_tgrapherrors_newtgrapherrors ::
               CInt ->
                 (Ptr CDouble) ->
                   (Ptr CDouble) ->
                     (Ptr CDouble) -> (Ptr CDouble) -> IO (Ptr RawTGraphErrors)
