{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1F.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1F.FFI
import HROOT.Hist.TH1F.Interface
import HROOT.Hist.TH1F.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayF.RawType
import HROOT.Core.TArrayF.Cast
import HROOT.Core.TArrayF.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH1F TH1F

instance ITH1 TH1F where
        add = xform2 c_th1f_add
        addBinContent = xform2 c_th1f_addbincontent
        chi2Test = xform3 c_th1f_chi2test
        computeIntegral = xform0 c_th1f_computeintegral
        directoryAutoAdd = xform1 c_th1f_directoryautoadd
        divide = xform5 c_th1f_divide
        drawCopyTH1 = xform1 c_th1f_drawcopyth1
        drawNormalized = xform2 c_th1f_drawnormalized
        drawPanelTH1 = xform0 c_th1f_drawpanelth1
        bufferEmpty = xform1 c_th1f_bufferempty
        evalF = xform2 c_th1f_evalf
        fFT = xform2 c_th1f_fft
        fill1 = xform1 c_th1f_fill1
        fill1w = xform2 c_th1f_fill1w
        fillN1 = xform4 c_th1f_filln1
        fillRandom = xform2 c_th1f_fillrandom
        findBin = xform3 c_th1f_findbin
        findFixBin = xform3 c_th1f_findfixbin
        findFirstBinAbove = xform2 c_th1f_findfirstbinabove
        findLastBinAbove = xform2 c_th1f_findlastbinabove
        fit = xform5 c_th1f_fit
        fitPanelTH1 = xform0 c_th1f_fitpanelth1
        getNdivisionA = xform1 c_th1f_getndivisiona
        getAxisColorA = xform1 c_th1f_getaxiscolora
        getLabelColorA = xform1 c_th1f_getlabelcolora
        getLabelFontA = xform1 c_th1f_getlabelfonta
        getLabelOffsetA = xform1 c_th1f_getlabeloffseta
        getLabelSizeA = xform1 c_th1f_getlabelsizea
        getTitleFontA = xform1 c_th1f_gettitlefonta
        getTitleOffsetA = xform1 c_th1f_gettitleoffseta
        getTitleSizeA = xform1 c_th1f_gettitlesizea
        getTickLengthA = xform1 c_th1f_getticklengtha
        getBarOffset = xform0 c_th1f_getbaroffset
        getBarWidth = xform0 c_th1f_getbarwidth
        getContour = xform1 c_th1f_getcontour
        getContourLevel = xform1 c_th1f_getcontourlevel
        getContourLevelPad = xform1 c_th1f_getcontourlevelpad
        getBin = xform3 c_th1f_getbin
        getBinCenter = xform1 c_th1f_getbincenter
        getBinContent1 = xform1 c_th1f_getbincontent1
        getBinContent2 = xform2 c_th1f_getbincontent2
        getBinContent3 = xform3 c_th1f_getbincontent3
        getBinError1 = xform1 c_th1f_getbinerror1
        getBinError2 = xform2 c_th1f_getbinerror2
        getBinError3 = xform3 c_th1f_getbinerror3
        getBinLowEdge = xform1 c_th1f_getbinlowedge
        getBinWidth = xform1 c_th1f_getbinwidth
        getCellContent = xform2 c_th1f_getcellcontent
        getCellError = xform2 c_th1f_getcellerror
        getEntries = xform0 c_th1f_getentries
        getEffectiveEntries = xform0 c_th1f_geteffectiveentries
        getFunction = xform1 c_th1f_getfunction
        getDimension = xform0 c_th1f_getdimension
        getKurtosis = xform1 c_th1f_getkurtosis
        getLowEdge = xform1 c_th1f_getlowedge
        getMaximumTH1 = xform1 c_th1f_getmaximumth1
        getMaximumBin = xform0 c_th1f_getmaximumbin
        getMaximumStored = xform0 c_th1f_getmaximumstored
        getMinimumTH1 = xform1 c_th1f_getminimumth1
        getMinimumBin = xform0 c_th1f_getminimumbin
        getMinimumStored = xform0 c_th1f_getminimumstored
        getMean = xform1 c_th1f_getmean
        getMeanError = xform1 c_th1f_getmeanerror
        getNbinsX = xform0 c_th1f_getnbinsx
        getNbinsY = xform0 c_th1f_getnbinsy
        getNbinsZ = xform0 c_th1f_getnbinsz
        getQuantilesTH1 = xform3 c_th1f_getquantilesth1
        getRandom = xform0 c_th1f_getrandom
        getStats = xform1 c_th1f_getstats
        getSumOfWeights = xform0 c_th1f_getsumofweights
        getSumw2 = xform0 c_th1f_getsumw2
        getSumw2N = xform0 c_th1f_getsumw2n
        getRMS = xform1 c_th1f_getrms
        getRMSError = xform1 c_th1f_getrmserror
        getSkewness = xform1 c_th1f_getskewness
        integral1 = xform3 c_th1f_integral1
        interpolate1 = xform1 c_th1f_interpolate1
        interpolate2 = xform2 c_th1f_interpolate2
        interpolate3 = xform3 c_th1f_interpolate3
        kolmogorovTest = xform2 c_th1f_kolmogorovtest
        labelsDeflate = xform1 c_th1f_labelsdeflate
        labelsInflate = xform1 c_th1f_labelsinflate
        labelsOption = xform2 c_th1f_labelsoption
        multiflyF = xform2 c_th1f_multiflyf
        multiply = xform5 c_th1f_multiply
        putStats = xform1 c_th1f_putstats
        rebin = xform3 c_th1f_rebin
        rebinAxis = xform2 c_th1f_rebinaxis
        rebuild = xform1 c_th1f_rebuild
        recursiveRemove = xform1 c_th1f_recursiveremove
        reset = xform1 c_th1f_reset
        resetStats = xform0 c_th1f_resetstats
        scale = xform2 c_th1f_scale
        setAxisColorA = xform2 c_th1f_setaxiscolora
        setAxisRange = xform3 c_th1f_setaxisrange
        setBarOffset = xform1 c_th1f_setbaroffset
        setBarWidth = xform1 c_th1f_setbarwidth
        setBinContent1 = xform2 c_th1f_setbincontent1
        setBinContent2 = xform3 c_th1f_setbincontent2
        setBinContent3 = xform4 c_th1f_setbincontent3
        setBinError1 = xform2 c_th1f_setbinerror1
        setBinError2 = xform3 c_th1f_setbinerror2
        setBinError3 = xform4 c_th1f_setbinerror3
        setBins1 = xform2 c_th1f_setbins1
        setBins2 = xform4 c_th1f_setbins2
        setBins3 = xform6 c_th1f_setbins3
        setBinsLength = xform1 c_th1f_setbinslength
        setBuffer = xform2 c_th1f_setbuffer
        setCellContent = xform3 c_th1f_setcellcontent
        setContent = xform1 c_th1f_setcontent
        setContour = xform2 c_th1f_setcontour
        setContourLevel = xform2 c_th1f_setcontourlevel
        setDirectory = xform1 c_th1f_setdirectory
        setEntries = xform1 c_th1f_setentries
        setError = xform1 c_th1f_seterror
        setLabelColorA = xform2 c_th1f_setlabelcolora
        setLabelSizeA = xform2 c_th1f_setlabelsizea
        setLabelFontA = xform2 c_th1f_setlabelfonta
        setLabelOffsetA = xform2 c_th1f_setlabeloffseta
        setMaximum = xform1 c_th1f_setmaximum
        setMinimum = xform1 c_th1f_setminimum
        setNormFactor = xform1 c_th1f_setnormfactor
        setStats = xform1 c_th1f_setstats
        setOption = xform1 c_th1f_setoption
        setXTitle = xform1 c_th1f_setxtitle
        setYTitle = xform1 c_th1f_setytitle
        setZTitle = xform1 c_th1f_setztitle
        showBackground = xform2 c_th1f_showbackground
        showPeaks = xform3 c_th1f_showpeaks
        smooth = xform2 c_th1f_smooth
        sumw2 = xform0 c_th1f_sumw2

instance ITArrayF TH1F

instance ITNamed TH1F where
        setName = xform1 c_th1f_setname
        setNameTitle = xform2 c_th1f_setnametitle
        setTitle = xform1 c_th1f_settitle

instance ITAttLine TH1F where
        getLineColor = xform0 c_th1f_getlinecolor
        getLineStyle = xform0 c_th1f_getlinestyle
        getLineWidth = xform0 c_th1f_getlinewidth
        resetAttLine = xform1 c_th1f_resetattline
        setLineAttributes = xform0 c_th1f_setlineattributes
        setLineColor = xform1 c_th1f_setlinecolor
        setLineStyle = xform1 c_th1f_setlinestyle
        setLineWidth = xform1 c_th1f_setlinewidth

instance ITAttFill TH1F where
        setFillColor = xform1 c_th1f_setfillcolor
        setFillStyle = xform1 c_th1f_setfillstyle

instance ITAttMarker TH1F where
        getMarkerColor = xform0 c_th1f_getmarkercolor
        getMarkerStyle = xform0 c_th1f_getmarkerstyle
        getMarkerSize = xform0 c_th1f_getmarkersize
        resetAttMarker = xform1 c_th1f_resetattmarker
        setMarkerAttributes = xform0 c_th1f_setmarkerattributes
        setMarkerColor = xform1 c_th1f_setmarkercolor
        setMarkerStyle = xform1 c_th1f_setmarkerstyle
        setMarkerSize = xform1 c_th1f_setmarkersize

instance ITObject TH1F where
        draw = xform1 c_th1f_draw
        findObject = xform1 c_th1f_findobject
        getName = xform0 c_th1f_getname
        isA = xform0 c_th1f_isa
        paint = xform1 c_th1f_paint
        printObj = xform1 c_th1f_printobj
        saveAs = xform2 c_th1f_saveas
        write = xform3 c_th1f_write

instance IDeletable TH1F where
        delete = xform0 c_th1f_delete

instance ITArray TH1F

newTH1F ::
          (Castable c1 CString, Castable c0 CString) =>
          c0 -> c1 -> CInt -> CDouble -> CDouble -> IO TH1F
newTH1F = xform4 c_th1f_newth1f
