{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1I.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH1I.RawType
import HROOT.Hist.TH1I.FFI
import HROOT.Hist.TH1I.Interface
import HROOT.Hist.TH1I.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayI.RawType
import HROOT.Core.TArrayI.Cast
import HROOT.Core.TArrayI.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH1I TH1I

instance ITH1 TH1I where
        add = xform2 c_th1i_add
        addBinContent = xform2 c_th1i_addbincontent
        chi2Test = xform3 c_th1i_chi2test
        computeIntegral = xform0 c_th1i_computeintegral
        directoryAutoAdd = xform1 c_th1i_directoryautoadd
        divide = xform5 c_th1i_divide
        drawCopyTH1 = xform1 c_th1i_drawcopyth1
        drawNormalized = xform2 c_th1i_drawnormalized
        drawPanelTH1 = xform0 c_th1i_drawpanelth1
        bufferEmpty = xform1 c_th1i_bufferempty
        evalF = xform2 c_th1i_evalf
        fFT = xform2 c_th1i_fft
        fill1 = xform1 c_th1i_fill1
        fill1w = xform2 c_th1i_fill1w
        fillN1 = xform4 c_th1i_filln1
        fillRandom = xform2 c_th1i_fillrandom
        findBin = xform3 c_th1i_findbin
        findFixBin = xform3 c_th1i_findfixbin
        findFirstBinAbove = xform2 c_th1i_findfirstbinabove
        findLastBinAbove = xform2 c_th1i_findlastbinabove
        fit = xform5 c_th1i_fit
        fitPanelTH1 = xform0 c_th1i_fitpanelth1
        getNdivisionA = xform1 c_th1i_getndivisiona
        getAxisColorA = xform1 c_th1i_getaxiscolora
        getLabelColorA = xform1 c_th1i_getlabelcolora
        getLabelFontA = xform1 c_th1i_getlabelfonta
        getLabelOffsetA = xform1 c_th1i_getlabeloffseta
        getLabelSizeA = xform1 c_th1i_getlabelsizea
        getTitleFontA = xform1 c_th1i_gettitlefonta
        getTitleOffsetA = xform1 c_th1i_gettitleoffseta
        getTitleSizeA = xform1 c_th1i_gettitlesizea
        getTickLengthA = xform1 c_th1i_getticklengtha
        getBarOffset = xform0 c_th1i_getbaroffset
        getBarWidth = xform0 c_th1i_getbarwidth
        getContour = xform1 c_th1i_getcontour
        getContourLevel = xform1 c_th1i_getcontourlevel
        getContourLevelPad = xform1 c_th1i_getcontourlevelpad
        getBin = xform3 c_th1i_getbin
        getBinCenter = xform1 c_th1i_getbincenter
        getBinContent1 = xform1 c_th1i_getbincontent1
        getBinContent2 = xform2 c_th1i_getbincontent2
        getBinContent3 = xform3 c_th1i_getbincontent3
        getBinError1 = xform1 c_th1i_getbinerror1
        getBinError2 = xform2 c_th1i_getbinerror2
        getBinError3 = xform3 c_th1i_getbinerror3
        getBinLowEdge = xform1 c_th1i_getbinlowedge
        getBinWidth = xform1 c_th1i_getbinwidth
        getCellContent = xform2 c_th1i_getcellcontent
        getCellError = xform2 c_th1i_getcellerror
        getEntries = xform0 c_th1i_getentries
        getEffectiveEntries = xform0 c_th1i_geteffectiveentries
        getFunction = xform1 c_th1i_getfunction
        getDimension = xform0 c_th1i_getdimension
        getKurtosis = xform1 c_th1i_getkurtosis
        getLowEdge = xform1 c_th1i_getlowedge
        getMaximumTH1 = xform1 c_th1i_getmaximumth1
        getMaximumBin = xform0 c_th1i_getmaximumbin
        getMaximumStored = xform0 c_th1i_getmaximumstored
        getMinimumTH1 = xform1 c_th1i_getminimumth1
        getMinimumBin = xform0 c_th1i_getminimumbin
        getMinimumStored = xform0 c_th1i_getminimumstored
        getMean = xform1 c_th1i_getmean
        getMeanError = xform1 c_th1i_getmeanerror
        getNbinsX = xform0 c_th1i_getnbinsx
        getNbinsY = xform0 c_th1i_getnbinsy
        getNbinsZ = xform0 c_th1i_getnbinsz
        getQuantilesTH1 = xform3 c_th1i_getquantilesth1
        getRandom = xform0 c_th1i_getrandom
        getStats = xform1 c_th1i_getstats
        getSumOfWeights = xform0 c_th1i_getsumofweights
        getSumw2 = xform0 c_th1i_getsumw2
        getSumw2N = xform0 c_th1i_getsumw2n
        getRMS = xform1 c_th1i_getrms
        getRMSError = xform1 c_th1i_getrmserror
        getSkewness = xform1 c_th1i_getskewness
        integral1 = xform3 c_th1i_integral1
        interpolate1 = xform1 c_th1i_interpolate1
        interpolate2 = xform2 c_th1i_interpolate2
        interpolate3 = xform3 c_th1i_interpolate3
        kolmogorovTest = xform2 c_th1i_kolmogorovtest
        labelsDeflate = xform1 c_th1i_labelsdeflate
        labelsInflate = xform1 c_th1i_labelsinflate
        labelsOption = xform2 c_th1i_labelsoption
        multiflyF = xform2 c_th1i_multiflyf
        multiply = xform5 c_th1i_multiply
        putStats = xform1 c_th1i_putstats
        rebin = xform3 c_th1i_rebin
        rebinAxis = xform2 c_th1i_rebinaxis
        rebuild = xform1 c_th1i_rebuild
        recursiveRemove = xform1 c_th1i_recursiveremove
        reset = xform1 c_th1i_reset
        resetStats = xform0 c_th1i_resetstats
        scale = xform2 c_th1i_scale
        setAxisColorA = xform2 c_th1i_setaxiscolora
        setAxisRange = xform3 c_th1i_setaxisrange
        setBarOffset = xform1 c_th1i_setbaroffset
        setBarWidth = xform1 c_th1i_setbarwidth
        setBinContent1 = xform2 c_th1i_setbincontent1
        setBinContent2 = xform3 c_th1i_setbincontent2
        setBinContent3 = xform4 c_th1i_setbincontent3
        setBinError1 = xform2 c_th1i_setbinerror1
        setBinError2 = xform3 c_th1i_setbinerror2
        setBinError3 = xform4 c_th1i_setbinerror3
        setBins1 = xform2 c_th1i_setbins1
        setBins2 = xform4 c_th1i_setbins2
        setBins3 = xform6 c_th1i_setbins3
        setBinsLength = xform1 c_th1i_setbinslength
        setBuffer = xform2 c_th1i_setbuffer
        setCellContent = xform3 c_th1i_setcellcontent
        setContent = xform1 c_th1i_setcontent
        setContour = xform2 c_th1i_setcontour
        setContourLevel = xform2 c_th1i_setcontourlevel
        setDirectory = xform1 c_th1i_setdirectory
        setEntries = xform1 c_th1i_setentries
        setError = xform1 c_th1i_seterror
        setLabelColorA = xform2 c_th1i_setlabelcolora
        setLabelSizeA = xform2 c_th1i_setlabelsizea
        setLabelFontA = xform2 c_th1i_setlabelfonta
        setLabelOffsetA = xform2 c_th1i_setlabeloffseta
        setMaximum = xform1 c_th1i_setmaximum
        setMinimum = xform1 c_th1i_setminimum
        setNormFactor = xform1 c_th1i_setnormfactor
        setStats = xform1 c_th1i_setstats
        setOption = xform1 c_th1i_setoption
        setXTitle = xform1 c_th1i_setxtitle
        setYTitle = xform1 c_th1i_setytitle
        setZTitle = xform1 c_th1i_setztitle
        showBackground = xform2 c_th1i_showbackground
        showPeaks = xform3 c_th1i_showpeaks
        smooth = xform2 c_th1i_smooth
        sumw2 = xform0 c_th1i_sumw2

instance ITArrayI TH1I

instance ITNamed TH1I where
        setName = xform1 c_th1i_setname
        setNameTitle = xform2 c_th1i_setnametitle
        setTitle = xform1 c_th1i_settitle

instance ITAttLine TH1I where
        getLineColor = xform0 c_th1i_getlinecolor
        getLineStyle = xform0 c_th1i_getlinestyle
        getLineWidth = xform0 c_th1i_getlinewidth
        resetAttLine = xform1 c_th1i_resetattline
        setLineAttributes = xform0 c_th1i_setlineattributes
        setLineColor = xform1 c_th1i_setlinecolor
        setLineStyle = xform1 c_th1i_setlinestyle
        setLineWidth = xform1 c_th1i_setlinewidth

instance ITAttFill TH1I where
        setFillColor = xform1 c_th1i_setfillcolor
        setFillStyle = xform1 c_th1i_setfillstyle

instance ITAttMarker TH1I where
        getMarkerColor = xform0 c_th1i_getmarkercolor
        getMarkerStyle = xform0 c_th1i_getmarkerstyle
        getMarkerSize = xform0 c_th1i_getmarkersize
        resetAttMarker = xform1 c_th1i_resetattmarker
        setMarkerAttributes = xform0 c_th1i_setmarkerattributes
        setMarkerColor = xform1 c_th1i_setmarkercolor
        setMarkerStyle = xform1 c_th1i_setmarkerstyle
        setMarkerSize = xform1 c_th1i_setmarkersize

instance ITObject TH1I where
        draw = xform1 c_th1i_draw
        findObject = xform1 c_th1i_findobject
        getName = xform0 c_th1i_getname
        isA = xform0 c_th1i_isa
        paint = xform1 c_th1i_paint
        printObj = xform1 c_th1i_printobj
        saveAs = xform2 c_th1i_saveas
        write = xform3 c_th1i_write

instance IDeletable TH1I where
        delete = xform0 c_th1i_delete

instance ITArray TH1I
