{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1K.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH1K.RawType
import HROOT.Hist.TH1K.FFI
import HROOT.Hist.TH1K.Interface
import HROOT.Hist.TH1K.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayF.RawType
import HROOT.Core.TArrayF.Cast
import HROOT.Core.TArrayF.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH1K TH1K

instance ITH1 TH1K where
        add = xform2 c_th1k_add
        addBinContent = xform2 c_th1k_addbincontent
        chi2Test = xform3 c_th1k_chi2test
        computeIntegral = xform0 c_th1k_computeintegral
        directoryAutoAdd = xform1 c_th1k_directoryautoadd
        divide = xform5 c_th1k_divide
        drawCopyTH1 = xform1 c_th1k_drawcopyth1
        drawNormalized = xform2 c_th1k_drawnormalized
        drawPanelTH1 = xform0 c_th1k_drawpanelth1
        bufferEmpty = xform1 c_th1k_bufferempty
        evalF = xform2 c_th1k_evalf
        fFT = xform2 c_th1k_fft
        fill1 = xform1 c_th1k_fill1
        fill1w = xform2 c_th1k_fill1w
        fillN1 = xform4 c_th1k_filln1
        fillRandom = xform2 c_th1k_fillrandom
        findBin = xform3 c_th1k_findbin
        findFixBin = xform3 c_th1k_findfixbin
        findFirstBinAbove = xform2 c_th1k_findfirstbinabove
        findLastBinAbove = xform2 c_th1k_findlastbinabove
        fit = xform5 c_th1k_fit
        fitPanelTH1 = xform0 c_th1k_fitpanelth1
        getNdivisionA = xform1 c_th1k_getndivisiona
        getAxisColorA = xform1 c_th1k_getaxiscolora
        getLabelColorA = xform1 c_th1k_getlabelcolora
        getLabelFontA = xform1 c_th1k_getlabelfonta
        getLabelOffsetA = xform1 c_th1k_getlabeloffseta
        getLabelSizeA = xform1 c_th1k_getlabelsizea
        getTitleFontA = xform1 c_th1k_gettitlefonta
        getTitleOffsetA = xform1 c_th1k_gettitleoffseta
        getTitleSizeA = xform1 c_th1k_gettitlesizea
        getTickLengthA = xform1 c_th1k_getticklengtha
        getBarOffset = xform0 c_th1k_getbaroffset
        getBarWidth = xform0 c_th1k_getbarwidth
        getContour = xform1 c_th1k_getcontour
        getContourLevel = xform1 c_th1k_getcontourlevel
        getContourLevelPad = xform1 c_th1k_getcontourlevelpad
        getBin = xform3 c_th1k_getbin
        getBinCenter = xform1 c_th1k_getbincenter
        getBinContent1 = xform1 c_th1k_getbincontent1
        getBinContent2 = xform2 c_th1k_getbincontent2
        getBinContent3 = xform3 c_th1k_getbincontent3
        getBinError1 = xform1 c_th1k_getbinerror1
        getBinError2 = xform2 c_th1k_getbinerror2
        getBinError3 = xform3 c_th1k_getbinerror3
        getBinLowEdge = xform1 c_th1k_getbinlowedge
        getBinWidth = xform1 c_th1k_getbinwidth
        getCellContent = xform2 c_th1k_getcellcontent
        getCellError = xform2 c_th1k_getcellerror
        getEntries = xform0 c_th1k_getentries
        getEffectiveEntries = xform0 c_th1k_geteffectiveentries
        getFunction = xform1 c_th1k_getfunction
        getDimension = xform0 c_th1k_getdimension
        getKurtosis = xform1 c_th1k_getkurtosis
        getLowEdge = xform1 c_th1k_getlowedge
        getMaximumTH1 = xform1 c_th1k_getmaximumth1
        getMaximumBin = xform0 c_th1k_getmaximumbin
        getMaximumStored = xform0 c_th1k_getmaximumstored
        getMinimumTH1 = xform1 c_th1k_getminimumth1
        getMinimumBin = xform0 c_th1k_getminimumbin
        getMinimumStored = xform0 c_th1k_getminimumstored
        getMean = xform1 c_th1k_getmean
        getMeanError = xform1 c_th1k_getmeanerror
        getNbinsX = xform0 c_th1k_getnbinsx
        getNbinsY = xform0 c_th1k_getnbinsy
        getNbinsZ = xform0 c_th1k_getnbinsz
        getQuantilesTH1 = xform3 c_th1k_getquantilesth1
        getRandom = xform0 c_th1k_getrandom
        getStats = xform1 c_th1k_getstats
        getSumOfWeights = xform0 c_th1k_getsumofweights
        getSumw2 = xform0 c_th1k_getsumw2
        getSumw2N = xform0 c_th1k_getsumw2n
        getRMS = xform1 c_th1k_getrms
        getRMSError = xform1 c_th1k_getrmserror
        getSkewness = xform1 c_th1k_getskewness
        integral1 = xform3 c_th1k_integral1
        interpolate1 = xform1 c_th1k_interpolate1
        interpolate2 = xform2 c_th1k_interpolate2
        interpolate3 = xform3 c_th1k_interpolate3
        kolmogorovTest = xform2 c_th1k_kolmogorovtest
        labelsDeflate = xform1 c_th1k_labelsdeflate
        labelsInflate = xform1 c_th1k_labelsinflate
        labelsOption = xform2 c_th1k_labelsoption
        multiflyF = xform2 c_th1k_multiflyf
        multiply = xform5 c_th1k_multiply
        putStats = xform1 c_th1k_putstats
        rebin = xform3 c_th1k_rebin
        rebinAxis = xform2 c_th1k_rebinaxis
        rebuild = xform1 c_th1k_rebuild
        recursiveRemove = xform1 c_th1k_recursiveremove
        reset = xform1 c_th1k_reset
        resetStats = xform0 c_th1k_resetstats
        scale = xform2 c_th1k_scale
        setAxisColorA = xform2 c_th1k_setaxiscolora
        setAxisRange = xform3 c_th1k_setaxisrange
        setBarOffset = xform1 c_th1k_setbaroffset
        setBarWidth = xform1 c_th1k_setbarwidth
        setBinContent1 = xform2 c_th1k_setbincontent1
        setBinContent2 = xform3 c_th1k_setbincontent2
        setBinContent3 = xform4 c_th1k_setbincontent3
        setBinError1 = xform2 c_th1k_setbinerror1
        setBinError2 = xform3 c_th1k_setbinerror2
        setBinError3 = xform4 c_th1k_setbinerror3
        setBins1 = xform2 c_th1k_setbins1
        setBins2 = xform4 c_th1k_setbins2
        setBins3 = xform6 c_th1k_setbins3
        setBinsLength = xform1 c_th1k_setbinslength
        setBuffer = xform2 c_th1k_setbuffer
        setCellContent = xform3 c_th1k_setcellcontent
        setContent = xform1 c_th1k_setcontent
        setContour = xform2 c_th1k_setcontour
        setContourLevel = xform2 c_th1k_setcontourlevel
        setDirectory = xform1 c_th1k_setdirectory
        setEntries = xform1 c_th1k_setentries
        setError = xform1 c_th1k_seterror
        setLabelColorA = xform2 c_th1k_setlabelcolora
        setLabelSizeA = xform2 c_th1k_setlabelsizea
        setLabelFontA = xform2 c_th1k_setlabelfonta
        setLabelOffsetA = xform2 c_th1k_setlabeloffseta
        setMaximum = xform1 c_th1k_setmaximum
        setMinimum = xform1 c_th1k_setminimum
        setNormFactor = xform1 c_th1k_setnormfactor
        setStats = xform1 c_th1k_setstats
        setOption = xform1 c_th1k_setoption
        setXTitle = xform1 c_th1k_setxtitle
        setYTitle = xform1 c_th1k_setytitle
        setZTitle = xform1 c_th1k_setztitle
        showBackground = xform2 c_th1k_showbackground
        showPeaks = xform3 c_th1k_showpeaks
        smooth = xform2 c_th1k_smooth
        sumw2 = xform0 c_th1k_sumw2

instance ITArrayF TH1K

instance ITNamed TH1K where
        setName = xform1 c_th1k_setname
        setNameTitle = xform2 c_th1k_setnametitle
        setTitle = xform1 c_th1k_settitle

instance ITAttLine TH1K where
        getLineColor = xform0 c_th1k_getlinecolor
        getLineStyle = xform0 c_th1k_getlinestyle
        getLineWidth = xform0 c_th1k_getlinewidth
        resetAttLine = xform1 c_th1k_resetattline
        setLineAttributes = xform0 c_th1k_setlineattributes
        setLineColor = xform1 c_th1k_setlinecolor
        setLineStyle = xform1 c_th1k_setlinestyle
        setLineWidth = xform1 c_th1k_setlinewidth

instance ITAttFill TH1K where
        setFillColor = xform1 c_th1k_setfillcolor
        setFillStyle = xform1 c_th1k_setfillstyle

instance ITAttMarker TH1K where
        getMarkerColor = xform0 c_th1k_getmarkercolor
        getMarkerStyle = xform0 c_th1k_getmarkerstyle
        getMarkerSize = xform0 c_th1k_getmarkersize
        resetAttMarker = xform1 c_th1k_resetattmarker
        setMarkerAttributes = xform0 c_th1k_setmarkerattributes
        setMarkerColor = xform1 c_th1k_setmarkercolor
        setMarkerStyle = xform1 c_th1k_setmarkerstyle
        setMarkerSize = xform1 c_th1k_setmarkersize

instance ITObject TH1K where
        draw = xform1 c_th1k_draw
        findObject = xform1 c_th1k_findobject
        getName = xform0 c_th1k_getname
        isA = xform0 c_th1k_isa
        paint = xform1 c_th1k_paint
        printObj = xform1 c_th1k_printobj
        saveAs = xform2 c_th1k_saveas
        write = xform3 c_th1k_write

instance IDeletable TH1K where
        delete = xform0 c_th1k_delete

instance ITArray TH1K
