{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2C.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH2C.RawType
import HROOT.Hist.TH2C.FFI
import HROOT.Hist.TH2C.Interface
import HROOT.Hist.TH2C.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayC.RawType
import HROOT.Core.TArrayC.Cast
import HROOT.Core.TArrayC.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH2C TH2C

instance ITH2 TH2C where
        fill2 = xform2 c_th2c_fill2
        fill2w = xform3 c_th2c_fill2w
        fillN2 = xform5 c_th2c_filln2
        fillRandom2 = xform2 c_th2c_fillrandom2
        findFirstBinAbove2 = xform2 c_th2c_findfirstbinabove2
        findLastBinAbove2 = xform2 c_th2c_findlastbinabove2
        fitSlicesX = xform6 c_th2c_fitslicesx
        fitSlicesY = xform6 c_th2c_fitslicesy
        getCorrelationFactor2 = xform2 c_th2c_getcorrelationfactor2
        getCovariance2 = xform2 c_th2c_getcovariance2
        integral2 = xform5 c_th2c_integral2
        rebinX2 = xform2 c_th2c_rebinx2
        rebinY2 = xform2 c_th2c_rebiny2
        rebin2D = xform3 c_th2c_rebin2d
        setShowProjectionX = xform1 c_th2c_setshowprojectionx
        setShowProjectionY = xform1 c_th2c_setshowprojectiony

instance ITArrayC TH2C

instance ITH1 TH2C where
        add = xform2 c_th2c_add
        addBinContent = xform2 c_th2c_addbincontent
        chi2Test = xform3 c_th2c_chi2test
        computeIntegral = xform0 c_th2c_computeintegral
        directoryAutoAdd = xform1 c_th2c_directoryautoadd
        divide = xform5 c_th2c_divide
        drawCopyTH1 = xform1 c_th2c_drawcopyth1
        drawNormalized = xform2 c_th2c_drawnormalized
        drawPanelTH1 = xform0 c_th2c_drawpanelth1
        bufferEmpty = xform1 c_th2c_bufferempty
        evalF = xform2 c_th2c_evalf
        fFT = xform2 c_th2c_fft
        fill1 = xform1 c_th2c_fill1
        fill1w = xform2 c_th2c_fill1w
        fillN1 = xform4 c_th2c_filln1
        fillRandom = xform2 c_th2c_fillrandom
        findBin = xform3 c_th2c_findbin
        findFixBin = xform3 c_th2c_findfixbin
        findFirstBinAbove = xform2 c_th2c_findfirstbinabove
        findLastBinAbove = xform2 c_th2c_findlastbinabove
        fit = xform5 c_th2c_fit
        fitPanelTH1 = xform0 c_th2c_fitpanelth1
        getNdivisionA = xform1 c_th2c_getndivisiona
        getAxisColorA = xform1 c_th2c_getaxiscolora
        getLabelColorA = xform1 c_th2c_getlabelcolora
        getLabelFontA = xform1 c_th2c_getlabelfonta
        getLabelOffsetA = xform1 c_th2c_getlabeloffseta
        getLabelSizeA = xform1 c_th2c_getlabelsizea
        getTitleFontA = xform1 c_th2c_gettitlefonta
        getTitleOffsetA = xform1 c_th2c_gettitleoffseta
        getTitleSizeA = xform1 c_th2c_gettitlesizea
        getTickLengthA = xform1 c_th2c_getticklengtha
        getBarOffset = xform0 c_th2c_getbaroffset
        getBarWidth = xform0 c_th2c_getbarwidth
        getContour = xform1 c_th2c_getcontour
        getContourLevel = xform1 c_th2c_getcontourlevel
        getContourLevelPad = xform1 c_th2c_getcontourlevelpad
        getBin = xform3 c_th2c_getbin
        getBinCenter = xform1 c_th2c_getbincenter
        getBinContent1 = xform1 c_th2c_getbincontent1
        getBinContent2 = xform2 c_th2c_getbincontent2
        getBinContent3 = xform3 c_th2c_getbincontent3
        getBinError1 = xform1 c_th2c_getbinerror1
        getBinError2 = xform2 c_th2c_getbinerror2
        getBinError3 = xform3 c_th2c_getbinerror3
        getBinLowEdge = xform1 c_th2c_getbinlowedge
        getBinWidth = xform1 c_th2c_getbinwidth
        getCellContent = xform2 c_th2c_getcellcontent
        getCellError = xform2 c_th2c_getcellerror
        getEntries = xform0 c_th2c_getentries
        getEffectiveEntries = xform0 c_th2c_geteffectiveentries
        getFunction = xform1 c_th2c_getfunction
        getDimension = xform0 c_th2c_getdimension
        getKurtosis = xform1 c_th2c_getkurtosis
        getLowEdge = xform1 c_th2c_getlowedge
        getMaximumTH1 = xform1 c_th2c_getmaximumth1
        getMaximumBin = xform0 c_th2c_getmaximumbin
        getMaximumStored = xform0 c_th2c_getmaximumstored
        getMinimumTH1 = xform1 c_th2c_getminimumth1
        getMinimumBin = xform0 c_th2c_getminimumbin
        getMinimumStored = xform0 c_th2c_getminimumstored
        getMean = xform1 c_th2c_getmean
        getMeanError = xform1 c_th2c_getmeanerror
        getNbinsX = xform0 c_th2c_getnbinsx
        getNbinsY = xform0 c_th2c_getnbinsy
        getNbinsZ = xform0 c_th2c_getnbinsz
        getQuantilesTH1 = xform3 c_th2c_getquantilesth1
        getRandom = xform0 c_th2c_getrandom
        getStats = xform1 c_th2c_getstats
        getSumOfWeights = xform0 c_th2c_getsumofweights
        getSumw2 = xform0 c_th2c_getsumw2
        getSumw2N = xform0 c_th2c_getsumw2n
        getRMS = xform1 c_th2c_getrms
        getRMSError = xform1 c_th2c_getrmserror
        getSkewness = xform1 c_th2c_getskewness
        integral1 = xform3 c_th2c_integral1
        interpolate1 = xform1 c_th2c_interpolate1
        interpolate2 = xform2 c_th2c_interpolate2
        interpolate3 = xform3 c_th2c_interpolate3
        kolmogorovTest = xform2 c_th2c_kolmogorovtest
        labelsDeflate = xform1 c_th2c_labelsdeflate
        labelsInflate = xform1 c_th2c_labelsinflate
        labelsOption = xform2 c_th2c_labelsoption
        multiflyF = xform2 c_th2c_multiflyf
        multiply = xform5 c_th2c_multiply
        putStats = xform1 c_th2c_putstats
        rebin = xform3 c_th2c_rebin
        rebinAxis = xform2 c_th2c_rebinaxis
        rebuild = xform1 c_th2c_rebuild
        recursiveRemove = xform1 c_th2c_recursiveremove
        reset = xform1 c_th2c_reset
        resetStats = xform0 c_th2c_resetstats
        scale = xform2 c_th2c_scale
        setAxisColorA = xform2 c_th2c_setaxiscolora
        setAxisRange = xform3 c_th2c_setaxisrange
        setBarOffset = xform1 c_th2c_setbaroffset
        setBarWidth = xform1 c_th2c_setbarwidth
        setBinContent1 = xform2 c_th2c_setbincontent1
        setBinContent2 = xform3 c_th2c_setbincontent2
        setBinContent3 = xform4 c_th2c_setbincontent3
        setBinError1 = xform2 c_th2c_setbinerror1
        setBinError2 = xform3 c_th2c_setbinerror2
        setBinError3 = xform4 c_th2c_setbinerror3
        setBins1 = xform2 c_th2c_setbins1
        setBins2 = xform4 c_th2c_setbins2
        setBins3 = xform6 c_th2c_setbins3
        setBinsLength = xform1 c_th2c_setbinslength
        setBuffer = xform2 c_th2c_setbuffer
        setCellContent = xform3 c_th2c_setcellcontent
        setContent = xform1 c_th2c_setcontent
        setContour = xform2 c_th2c_setcontour
        setContourLevel = xform2 c_th2c_setcontourlevel
        setDirectory = xform1 c_th2c_setdirectory
        setEntries = xform1 c_th2c_setentries
        setError = xform1 c_th2c_seterror
        setLabelColorA = xform2 c_th2c_setlabelcolora
        setLabelSizeA = xform2 c_th2c_setlabelsizea
        setLabelFontA = xform2 c_th2c_setlabelfonta
        setLabelOffsetA = xform2 c_th2c_setlabeloffseta
        setMaximum = xform1 c_th2c_setmaximum
        setMinimum = xform1 c_th2c_setminimum
        setNormFactor = xform1 c_th2c_setnormfactor
        setStats = xform1 c_th2c_setstats
        setOption = xform1 c_th2c_setoption
        setXTitle = xform1 c_th2c_setxtitle
        setYTitle = xform1 c_th2c_setytitle
        setZTitle = xform1 c_th2c_setztitle
        showBackground = xform2 c_th2c_showbackground
        showPeaks = xform3 c_th2c_showpeaks
        smooth = xform2 c_th2c_smooth
        sumw2 = xform0 c_th2c_sumw2

instance ITNamed TH2C where
        setName = xform1 c_th2c_setname
        setNameTitle = xform2 c_th2c_setnametitle
        setTitle = xform1 c_th2c_settitle

instance ITAttLine TH2C where
        getLineColor = xform0 c_th2c_getlinecolor
        getLineStyle = xform0 c_th2c_getlinestyle
        getLineWidth = xform0 c_th2c_getlinewidth
        resetAttLine = xform1 c_th2c_resetattline
        setLineAttributes = xform0 c_th2c_setlineattributes
        setLineColor = xform1 c_th2c_setlinecolor
        setLineStyle = xform1 c_th2c_setlinestyle
        setLineWidth = xform1 c_th2c_setlinewidth

instance ITAttFill TH2C where
        setFillColor = xform1 c_th2c_setfillcolor
        setFillStyle = xform1 c_th2c_setfillstyle

instance ITAttMarker TH2C where
        getMarkerColor = xform0 c_th2c_getmarkercolor
        getMarkerStyle = xform0 c_th2c_getmarkerstyle
        getMarkerSize = xform0 c_th2c_getmarkersize
        resetAttMarker = xform1 c_th2c_resetattmarker
        setMarkerAttributes = xform0 c_th2c_setmarkerattributes
        setMarkerColor = xform1 c_th2c_setmarkercolor
        setMarkerStyle = xform1 c_th2c_setmarkerstyle
        setMarkerSize = xform1 c_th2c_setmarkersize

instance ITObject TH2C where
        draw = xform1 c_th2c_draw
        findObject = xform1 c_th2c_findobject
        getName = xform0 c_th2c_getname
        isA = xform0 c_th2c_isa
        paint = xform1 c_th2c_paint
        printObj = xform1 c_th2c_printobj
        saveAs = xform2 c_th2c_saveas
        write = xform3 c_th2c_write

instance IDeletable TH2C where
        delete = xform0 c_th2c_delete

instance ITArray TH2C
