{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2D.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH2D.RawType
import HROOT.Hist.TH2D.FFI
import HROOT.Hist.TH2D.Interface
import HROOT.Hist.TH2D.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH2D TH2D

instance ITH2 TH2D where
        fill2 = xform2 c_th2d_fill2
        fill2w = xform3 c_th2d_fill2w
        fillN2 = xform5 c_th2d_filln2
        fillRandom2 = xform2 c_th2d_fillrandom2
        findFirstBinAbove2 = xform2 c_th2d_findfirstbinabove2
        findLastBinAbove2 = xform2 c_th2d_findlastbinabove2
        fitSlicesX = xform6 c_th2d_fitslicesx
        fitSlicesY = xform6 c_th2d_fitslicesy
        getCorrelationFactor2 = xform2 c_th2d_getcorrelationfactor2
        getCovariance2 = xform2 c_th2d_getcovariance2
        integral2 = xform5 c_th2d_integral2
        rebinX2 = xform2 c_th2d_rebinx2
        rebinY2 = xform2 c_th2d_rebiny2
        rebin2D = xform3 c_th2d_rebin2d
        setShowProjectionX = xform1 c_th2d_setshowprojectionx
        setShowProjectionY = xform1 c_th2d_setshowprojectiony

instance ITArrayD TH2D

instance ITH1 TH2D where
        add = xform2 c_th2d_add
        addBinContent = xform2 c_th2d_addbincontent
        chi2Test = xform3 c_th2d_chi2test
        computeIntegral = xform0 c_th2d_computeintegral
        directoryAutoAdd = xform1 c_th2d_directoryautoadd
        divide = xform5 c_th2d_divide
        drawCopyTH1 = xform1 c_th2d_drawcopyth1
        drawNormalized = xform2 c_th2d_drawnormalized
        drawPanelTH1 = xform0 c_th2d_drawpanelth1
        bufferEmpty = xform1 c_th2d_bufferempty
        evalF = xform2 c_th2d_evalf
        fFT = xform2 c_th2d_fft
        fill1 = xform1 c_th2d_fill1
        fill1w = xform2 c_th2d_fill1w
        fillN1 = xform4 c_th2d_filln1
        fillRandom = xform2 c_th2d_fillrandom
        findBin = xform3 c_th2d_findbin
        findFixBin = xform3 c_th2d_findfixbin
        findFirstBinAbove = xform2 c_th2d_findfirstbinabove
        findLastBinAbove = xform2 c_th2d_findlastbinabove
        fit = xform5 c_th2d_fit
        fitPanelTH1 = xform0 c_th2d_fitpanelth1
        getNdivisionA = xform1 c_th2d_getndivisiona
        getAxisColorA = xform1 c_th2d_getaxiscolora
        getLabelColorA = xform1 c_th2d_getlabelcolora
        getLabelFontA = xform1 c_th2d_getlabelfonta
        getLabelOffsetA = xform1 c_th2d_getlabeloffseta
        getLabelSizeA = xform1 c_th2d_getlabelsizea
        getTitleFontA = xform1 c_th2d_gettitlefonta
        getTitleOffsetA = xform1 c_th2d_gettitleoffseta
        getTitleSizeA = xform1 c_th2d_gettitlesizea
        getTickLengthA = xform1 c_th2d_getticklengtha
        getBarOffset = xform0 c_th2d_getbaroffset
        getBarWidth = xform0 c_th2d_getbarwidth
        getContour = xform1 c_th2d_getcontour
        getContourLevel = xform1 c_th2d_getcontourlevel
        getContourLevelPad = xform1 c_th2d_getcontourlevelpad
        getBin = xform3 c_th2d_getbin
        getBinCenter = xform1 c_th2d_getbincenter
        getBinContent1 = xform1 c_th2d_getbincontent1
        getBinContent2 = xform2 c_th2d_getbincontent2
        getBinContent3 = xform3 c_th2d_getbincontent3
        getBinError1 = xform1 c_th2d_getbinerror1
        getBinError2 = xform2 c_th2d_getbinerror2
        getBinError3 = xform3 c_th2d_getbinerror3
        getBinLowEdge = xform1 c_th2d_getbinlowedge
        getBinWidth = xform1 c_th2d_getbinwidth
        getCellContent = xform2 c_th2d_getcellcontent
        getCellError = xform2 c_th2d_getcellerror
        getEntries = xform0 c_th2d_getentries
        getEffectiveEntries = xform0 c_th2d_geteffectiveentries
        getFunction = xform1 c_th2d_getfunction
        getDimension = xform0 c_th2d_getdimension
        getKurtosis = xform1 c_th2d_getkurtosis
        getLowEdge = xform1 c_th2d_getlowedge
        getMaximumTH1 = xform1 c_th2d_getmaximumth1
        getMaximumBin = xform0 c_th2d_getmaximumbin
        getMaximumStored = xform0 c_th2d_getmaximumstored
        getMinimumTH1 = xform1 c_th2d_getminimumth1
        getMinimumBin = xform0 c_th2d_getminimumbin
        getMinimumStored = xform0 c_th2d_getminimumstored
        getMean = xform1 c_th2d_getmean
        getMeanError = xform1 c_th2d_getmeanerror
        getNbinsX = xform0 c_th2d_getnbinsx
        getNbinsY = xform0 c_th2d_getnbinsy
        getNbinsZ = xform0 c_th2d_getnbinsz
        getQuantilesTH1 = xform3 c_th2d_getquantilesth1
        getRandom = xform0 c_th2d_getrandom
        getStats = xform1 c_th2d_getstats
        getSumOfWeights = xform0 c_th2d_getsumofweights
        getSumw2 = xform0 c_th2d_getsumw2
        getSumw2N = xform0 c_th2d_getsumw2n
        getRMS = xform1 c_th2d_getrms
        getRMSError = xform1 c_th2d_getrmserror
        getSkewness = xform1 c_th2d_getskewness
        integral1 = xform3 c_th2d_integral1
        interpolate1 = xform1 c_th2d_interpolate1
        interpolate2 = xform2 c_th2d_interpolate2
        interpolate3 = xform3 c_th2d_interpolate3
        kolmogorovTest = xform2 c_th2d_kolmogorovtest
        labelsDeflate = xform1 c_th2d_labelsdeflate
        labelsInflate = xform1 c_th2d_labelsinflate
        labelsOption = xform2 c_th2d_labelsoption
        multiflyF = xform2 c_th2d_multiflyf
        multiply = xform5 c_th2d_multiply
        putStats = xform1 c_th2d_putstats
        rebin = xform3 c_th2d_rebin
        rebinAxis = xform2 c_th2d_rebinaxis
        rebuild = xform1 c_th2d_rebuild
        recursiveRemove = xform1 c_th2d_recursiveremove
        reset = xform1 c_th2d_reset
        resetStats = xform0 c_th2d_resetstats
        scale = xform2 c_th2d_scale
        setAxisColorA = xform2 c_th2d_setaxiscolora
        setAxisRange = xform3 c_th2d_setaxisrange
        setBarOffset = xform1 c_th2d_setbaroffset
        setBarWidth = xform1 c_th2d_setbarwidth
        setBinContent1 = xform2 c_th2d_setbincontent1
        setBinContent2 = xform3 c_th2d_setbincontent2
        setBinContent3 = xform4 c_th2d_setbincontent3
        setBinError1 = xform2 c_th2d_setbinerror1
        setBinError2 = xform3 c_th2d_setbinerror2
        setBinError3 = xform4 c_th2d_setbinerror3
        setBins1 = xform2 c_th2d_setbins1
        setBins2 = xform4 c_th2d_setbins2
        setBins3 = xform6 c_th2d_setbins3
        setBinsLength = xform1 c_th2d_setbinslength
        setBuffer = xform2 c_th2d_setbuffer
        setCellContent = xform3 c_th2d_setcellcontent
        setContent = xform1 c_th2d_setcontent
        setContour = xform2 c_th2d_setcontour
        setContourLevel = xform2 c_th2d_setcontourlevel
        setDirectory = xform1 c_th2d_setdirectory
        setEntries = xform1 c_th2d_setentries
        setError = xform1 c_th2d_seterror
        setLabelColorA = xform2 c_th2d_setlabelcolora
        setLabelSizeA = xform2 c_th2d_setlabelsizea
        setLabelFontA = xform2 c_th2d_setlabelfonta
        setLabelOffsetA = xform2 c_th2d_setlabeloffseta
        setMaximum = xform1 c_th2d_setmaximum
        setMinimum = xform1 c_th2d_setminimum
        setNormFactor = xform1 c_th2d_setnormfactor
        setStats = xform1 c_th2d_setstats
        setOption = xform1 c_th2d_setoption
        setXTitle = xform1 c_th2d_setxtitle
        setYTitle = xform1 c_th2d_setytitle
        setZTitle = xform1 c_th2d_setztitle
        showBackground = xform2 c_th2d_showbackground
        showPeaks = xform3 c_th2d_showpeaks
        smooth = xform2 c_th2d_smooth
        sumw2 = xform0 c_th2d_sumw2

instance ITNamed TH2D where
        setName = xform1 c_th2d_setname
        setNameTitle = xform2 c_th2d_setnametitle
        setTitle = xform1 c_th2d_settitle

instance ITAttLine TH2D where
        getLineColor = xform0 c_th2d_getlinecolor
        getLineStyle = xform0 c_th2d_getlinestyle
        getLineWidth = xform0 c_th2d_getlinewidth
        resetAttLine = xform1 c_th2d_resetattline
        setLineAttributes = xform0 c_th2d_setlineattributes
        setLineColor = xform1 c_th2d_setlinecolor
        setLineStyle = xform1 c_th2d_setlinestyle
        setLineWidth = xform1 c_th2d_setlinewidth

instance ITAttFill TH2D where
        setFillColor = xform1 c_th2d_setfillcolor
        setFillStyle = xform1 c_th2d_setfillstyle

instance ITAttMarker TH2D where
        getMarkerColor = xform0 c_th2d_getmarkercolor
        getMarkerStyle = xform0 c_th2d_getmarkerstyle
        getMarkerSize = xform0 c_th2d_getmarkersize
        resetAttMarker = xform1 c_th2d_resetattmarker
        setMarkerAttributes = xform0 c_th2d_setmarkerattributes
        setMarkerColor = xform1 c_th2d_setmarkercolor
        setMarkerStyle = xform1 c_th2d_setmarkerstyle
        setMarkerSize = xform1 c_th2d_setmarkersize

instance ITObject TH2D where
        draw = xform1 c_th2d_draw
        findObject = xform1 c_th2d_findobject
        getName = xform0 c_th2d_getname
        isA = xform0 c_th2d_isa
        paint = xform1 c_th2d_paint
        printObj = xform1 c_th2d_printobj
        saveAs = xform2 c_th2d_saveas
        write = xform3 c_th2d_write

instance IDeletable TH2D where
        delete = xform0 c_th2d_delete

instance ITArray TH2D

newTH2D ::
          (Castable c1 CString, Castable c0 CString) =>
          c0 ->
            c1 ->
              CInt -> CDouble -> CDouble -> CInt -> CDouble -> CDouble -> IO TH2D
newTH2D = xform7 c_th2d_newth2d
