{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2F.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH2F.RawType
import HROOT.Hist.TH2F.FFI
import HROOT.Hist.TH2F.Interface
import HROOT.Hist.TH2F.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayF.RawType
import HROOT.Core.TArrayF.Cast
import HROOT.Core.TArrayF.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH2F TH2F

instance ITH2 TH2F where
        fill2 = xform2 c_th2f_fill2
        fill2w = xform3 c_th2f_fill2w
        fillN2 = xform5 c_th2f_filln2
        fillRandom2 = xform2 c_th2f_fillrandom2
        findFirstBinAbove2 = xform2 c_th2f_findfirstbinabove2
        findLastBinAbove2 = xform2 c_th2f_findlastbinabove2
        fitSlicesX = xform6 c_th2f_fitslicesx
        fitSlicesY = xform6 c_th2f_fitslicesy
        getCorrelationFactor2 = xform2 c_th2f_getcorrelationfactor2
        getCovariance2 = xform2 c_th2f_getcovariance2
        integral2 = xform5 c_th2f_integral2
        rebinX2 = xform2 c_th2f_rebinx2
        rebinY2 = xform2 c_th2f_rebiny2
        rebin2D = xform3 c_th2f_rebin2d
        setShowProjectionX = xform1 c_th2f_setshowprojectionx
        setShowProjectionY = xform1 c_th2f_setshowprojectiony

instance ITArrayF TH2F

instance ITH1 TH2F where
        add = xform2 c_th2f_add
        addBinContent = xform2 c_th2f_addbincontent
        chi2Test = xform3 c_th2f_chi2test
        computeIntegral = xform0 c_th2f_computeintegral
        directoryAutoAdd = xform1 c_th2f_directoryautoadd
        divide = xform5 c_th2f_divide
        drawCopyTH1 = xform1 c_th2f_drawcopyth1
        drawNormalized = xform2 c_th2f_drawnormalized
        drawPanelTH1 = xform0 c_th2f_drawpanelth1
        bufferEmpty = xform1 c_th2f_bufferempty
        evalF = xform2 c_th2f_evalf
        fFT = xform2 c_th2f_fft
        fill1 = xform1 c_th2f_fill1
        fill1w = xform2 c_th2f_fill1w
        fillN1 = xform4 c_th2f_filln1
        fillRandom = xform2 c_th2f_fillrandom
        findBin = xform3 c_th2f_findbin
        findFixBin = xform3 c_th2f_findfixbin
        findFirstBinAbove = xform2 c_th2f_findfirstbinabove
        findLastBinAbove = xform2 c_th2f_findlastbinabove
        fit = xform5 c_th2f_fit
        fitPanelTH1 = xform0 c_th2f_fitpanelth1
        getNdivisionA = xform1 c_th2f_getndivisiona
        getAxisColorA = xform1 c_th2f_getaxiscolora
        getLabelColorA = xform1 c_th2f_getlabelcolora
        getLabelFontA = xform1 c_th2f_getlabelfonta
        getLabelOffsetA = xform1 c_th2f_getlabeloffseta
        getLabelSizeA = xform1 c_th2f_getlabelsizea
        getTitleFontA = xform1 c_th2f_gettitlefonta
        getTitleOffsetA = xform1 c_th2f_gettitleoffseta
        getTitleSizeA = xform1 c_th2f_gettitlesizea
        getTickLengthA = xform1 c_th2f_getticklengtha
        getBarOffset = xform0 c_th2f_getbaroffset
        getBarWidth = xform0 c_th2f_getbarwidth
        getContour = xform1 c_th2f_getcontour
        getContourLevel = xform1 c_th2f_getcontourlevel
        getContourLevelPad = xform1 c_th2f_getcontourlevelpad
        getBin = xform3 c_th2f_getbin
        getBinCenter = xform1 c_th2f_getbincenter
        getBinContent1 = xform1 c_th2f_getbincontent1
        getBinContent2 = xform2 c_th2f_getbincontent2
        getBinContent3 = xform3 c_th2f_getbincontent3
        getBinError1 = xform1 c_th2f_getbinerror1
        getBinError2 = xform2 c_th2f_getbinerror2
        getBinError3 = xform3 c_th2f_getbinerror3
        getBinLowEdge = xform1 c_th2f_getbinlowedge
        getBinWidth = xform1 c_th2f_getbinwidth
        getCellContent = xform2 c_th2f_getcellcontent
        getCellError = xform2 c_th2f_getcellerror
        getEntries = xform0 c_th2f_getentries
        getEffectiveEntries = xform0 c_th2f_geteffectiveentries
        getFunction = xform1 c_th2f_getfunction
        getDimension = xform0 c_th2f_getdimension
        getKurtosis = xform1 c_th2f_getkurtosis
        getLowEdge = xform1 c_th2f_getlowedge
        getMaximumTH1 = xform1 c_th2f_getmaximumth1
        getMaximumBin = xform0 c_th2f_getmaximumbin
        getMaximumStored = xform0 c_th2f_getmaximumstored
        getMinimumTH1 = xform1 c_th2f_getminimumth1
        getMinimumBin = xform0 c_th2f_getminimumbin
        getMinimumStored = xform0 c_th2f_getminimumstored
        getMean = xform1 c_th2f_getmean
        getMeanError = xform1 c_th2f_getmeanerror
        getNbinsX = xform0 c_th2f_getnbinsx
        getNbinsY = xform0 c_th2f_getnbinsy
        getNbinsZ = xform0 c_th2f_getnbinsz
        getQuantilesTH1 = xform3 c_th2f_getquantilesth1
        getRandom = xform0 c_th2f_getrandom
        getStats = xform1 c_th2f_getstats
        getSumOfWeights = xform0 c_th2f_getsumofweights
        getSumw2 = xform0 c_th2f_getsumw2
        getSumw2N = xform0 c_th2f_getsumw2n
        getRMS = xform1 c_th2f_getrms
        getRMSError = xform1 c_th2f_getrmserror
        getSkewness = xform1 c_th2f_getskewness
        integral1 = xform3 c_th2f_integral1
        interpolate1 = xform1 c_th2f_interpolate1
        interpolate2 = xform2 c_th2f_interpolate2
        interpolate3 = xform3 c_th2f_interpolate3
        kolmogorovTest = xform2 c_th2f_kolmogorovtest
        labelsDeflate = xform1 c_th2f_labelsdeflate
        labelsInflate = xform1 c_th2f_labelsinflate
        labelsOption = xform2 c_th2f_labelsoption
        multiflyF = xform2 c_th2f_multiflyf
        multiply = xform5 c_th2f_multiply
        putStats = xform1 c_th2f_putstats
        rebin = xform3 c_th2f_rebin
        rebinAxis = xform2 c_th2f_rebinaxis
        rebuild = xform1 c_th2f_rebuild
        recursiveRemove = xform1 c_th2f_recursiveremove
        reset = xform1 c_th2f_reset
        resetStats = xform0 c_th2f_resetstats
        scale = xform2 c_th2f_scale
        setAxisColorA = xform2 c_th2f_setaxiscolora
        setAxisRange = xform3 c_th2f_setaxisrange
        setBarOffset = xform1 c_th2f_setbaroffset
        setBarWidth = xform1 c_th2f_setbarwidth
        setBinContent1 = xform2 c_th2f_setbincontent1
        setBinContent2 = xform3 c_th2f_setbincontent2
        setBinContent3 = xform4 c_th2f_setbincontent3
        setBinError1 = xform2 c_th2f_setbinerror1
        setBinError2 = xform3 c_th2f_setbinerror2
        setBinError3 = xform4 c_th2f_setbinerror3
        setBins1 = xform2 c_th2f_setbins1
        setBins2 = xform4 c_th2f_setbins2
        setBins3 = xform6 c_th2f_setbins3
        setBinsLength = xform1 c_th2f_setbinslength
        setBuffer = xform2 c_th2f_setbuffer
        setCellContent = xform3 c_th2f_setcellcontent
        setContent = xform1 c_th2f_setcontent
        setContour = xform2 c_th2f_setcontour
        setContourLevel = xform2 c_th2f_setcontourlevel
        setDirectory = xform1 c_th2f_setdirectory
        setEntries = xform1 c_th2f_setentries
        setError = xform1 c_th2f_seterror
        setLabelColorA = xform2 c_th2f_setlabelcolora
        setLabelSizeA = xform2 c_th2f_setlabelsizea
        setLabelFontA = xform2 c_th2f_setlabelfonta
        setLabelOffsetA = xform2 c_th2f_setlabeloffseta
        setMaximum = xform1 c_th2f_setmaximum
        setMinimum = xform1 c_th2f_setminimum
        setNormFactor = xform1 c_th2f_setnormfactor
        setStats = xform1 c_th2f_setstats
        setOption = xform1 c_th2f_setoption
        setXTitle = xform1 c_th2f_setxtitle
        setYTitle = xform1 c_th2f_setytitle
        setZTitle = xform1 c_th2f_setztitle
        showBackground = xform2 c_th2f_showbackground
        showPeaks = xform3 c_th2f_showpeaks
        smooth = xform2 c_th2f_smooth
        sumw2 = xform0 c_th2f_sumw2

instance ITNamed TH2F where
        setName = xform1 c_th2f_setname
        setNameTitle = xform2 c_th2f_setnametitle
        setTitle = xform1 c_th2f_settitle

instance ITAttLine TH2F where
        getLineColor = xform0 c_th2f_getlinecolor
        getLineStyle = xform0 c_th2f_getlinestyle
        getLineWidth = xform0 c_th2f_getlinewidth
        resetAttLine = xform1 c_th2f_resetattline
        setLineAttributes = xform0 c_th2f_setlineattributes
        setLineColor = xform1 c_th2f_setlinecolor
        setLineStyle = xform1 c_th2f_setlinestyle
        setLineWidth = xform1 c_th2f_setlinewidth

instance ITAttFill TH2F where
        setFillColor = xform1 c_th2f_setfillcolor
        setFillStyle = xform1 c_th2f_setfillstyle

instance ITAttMarker TH2F where
        getMarkerColor = xform0 c_th2f_getmarkercolor
        getMarkerStyle = xform0 c_th2f_getmarkerstyle
        getMarkerSize = xform0 c_th2f_getmarkersize
        resetAttMarker = xform1 c_th2f_resetattmarker
        setMarkerAttributes = xform0 c_th2f_setmarkerattributes
        setMarkerColor = xform1 c_th2f_setmarkercolor
        setMarkerStyle = xform1 c_th2f_setmarkerstyle
        setMarkerSize = xform1 c_th2f_setmarkersize

instance ITObject TH2F where
        draw = xform1 c_th2f_draw
        findObject = xform1 c_th2f_findobject
        getName = xform0 c_th2f_getname
        isA = xform0 c_th2f_isa
        paint = xform1 c_th2f_paint
        printObj = xform1 c_th2f_printobj
        saveAs = xform2 c_th2f_saveas
        write = xform3 c_th2f_write

instance IDeletable TH2F where
        delete = xform0 c_th2f_delete

instance ITArray TH2F

newTH2F ::
          (Castable c1 CString, Castable c0 CString) =>
          c0 ->
            c1 ->
              CInt -> CDouble -> CDouble -> CInt -> CDouble -> CDouble -> IO TH2F
newTH2F = xform7 c_th2f_newth2f
