{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2Poly.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH2Poly.RawType
import HROOT.Hist.TH2Poly.FFI
import HROOT.Hist.TH2Poly.Interface
import HROOT.Hist.TH2Poly.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITH2Poly TH2Poly

instance ITH2 TH2Poly where
        fill2 = xform2 c_th2poly_fill2
        fill2w = xform3 c_th2poly_fill2w
        fillN2 = xform5 c_th2poly_filln2
        fillRandom2 = xform2 c_th2poly_fillrandom2
        findFirstBinAbove2 = xform2 c_th2poly_findfirstbinabove2
        findLastBinAbove2 = xform2 c_th2poly_findlastbinabove2
        fitSlicesX = xform6 c_th2poly_fitslicesx
        fitSlicesY = xform6 c_th2poly_fitslicesy
        getCorrelationFactor2 = xform2 c_th2poly_getcorrelationfactor2
        getCovariance2 = xform2 c_th2poly_getcovariance2
        integral2 = xform5 c_th2poly_integral2
        rebinX2 = xform2 c_th2poly_rebinx2
        rebinY2 = xform2 c_th2poly_rebiny2
        rebin2D = xform3 c_th2poly_rebin2d
        setShowProjectionX = xform1 c_th2poly_setshowprojectionx
        setShowProjectionY = xform1 c_th2poly_setshowprojectiony

instance ITH1 TH2Poly where
        add = xform2 c_th2poly_add
        addBinContent = xform2 c_th2poly_addbincontent
        chi2Test = xform3 c_th2poly_chi2test
        computeIntegral = xform0 c_th2poly_computeintegral
        directoryAutoAdd = xform1 c_th2poly_directoryautoadd
        divide = xform5 c_th2poly_divide
        drawCopyTH1 = xform1 c_th2poly_drawcopyth1
        drawNormalized = xform2 c_th2poly_drawnormalized
        drawPanelTH1 = xform0 c_th2poly_drawpanelth1
        bufferEmpty = xform1 c_th2poly_bufferempty
        evalF = xform2 c_th2poly_evalf
        fFT = xform2 c_th2poly_fft
        fill1 = xform1 c_th2poly_fill1
        fill1w = xform2 c_th2poly_fill1w
        fillN1 = xform4 c_th2poly_filln1
        fillRandom = xform2 c_th2poly_fillrandom
        findBin = xform3 c_th2poly_findbin
        findFixBin = xform3 c_th2poly_findfixbin
        findFirstBinAbove = xform2 c_th2poly_findfirstbinabove
        findLastBinAbove = xform2 c_th2poly_findlastbinabove
        fit = xform5 c_th2poly_fit
        fitPanelTH1 = xform0 c_th2poly_fitpanelth1
        getNdivisionA = xform1 c_th2poly_getndivisiona
        getAxisColorA = xform1 c_th2poly_getaxiscolora
        getLabelColorA = xform1 c_th2poly_getlabelcolora
        getLabelFontA = xform1 c_th2poly_getlabelfonta
        getLabelOffsetA = xform1 c_th2poly_getlabeloffseta
        getLabelSizeA = xform1 c_th2poly_getlabelsizea
        getTitleFontA = xform1 c_th2poly_gettitlefonta
        getTitleOffsetA = xform1 c_th2poly_gettitleoffseta
        getTitleSizeA = xform1 c_th2poly_gettitlesizea
        getTickLengthA = xform1 c_th2poly_getticklengtha
        getBarOffset = xform0 c_th2poly_getbaroffset
        getBarWidth = xform0 c_th2poly_getbarwidth
        getContour = xform1 c_th2poly_getcontour
        getContourLevel = xform1 c_th2poly_getcontourlevel
        getContourLevelPad = xform1 c_th2poly_getcontourlevelpad
        getBin = xform3 c_th2poly_getbin
        getBinCenter = xform1 c_th2poly_getbincenter
        getBinContent1 = xform1 c_th2poly_getbincontent1
        getBinContent2 = xform2 c_th2poly_getbincontent2
        getBinContent3 = xform3 c_th2poly_getbincontent3
        getBinError1 = xform1 c_th2poly_getbinerror1
        getBinError2 = xform2 c_th2poly_getbinerror2
        getBinError3 = xform3 c_th2poly_getbinerror3
        getBinLowEdge = xform1 c_th2poly_getbinlowedge
        getBinWidth = xform1 c_th2poly_getbinwidth
        getCellContent = xform2 c_th2poly_getcellcontent
        getCellError = xform2 c_th2poly_getcellerror
        getEntries = xform0 c_th2poly_getentries
        getEffectiveEntries = xform0 c_th2poly_geteffectiveentries
        getFunction = xform1 c_th2poly_getfunction
        getDimension = xform0 c_th2poly_getdimension
        getKurtosis = xform1 c_th2poly_getkurtosis
        getLowEdge = xform1 c_th2poly_getlowedge
        getMaximumTH1 = xform1 c_th2poly_getmaximumth1
        getMaximumBin = xform0 c_th2poly_getmaximumbin
        getMaximumStored = xform0 c_th2poly_getmaximumstored
        getMinimumTH1 = xform1 c_th2poly_getminimumth1
        getMinimumBin = xform0 c_th2poly_getminimumbin
        getMinimumStored = xform0 c_th2poly_getminimumstored
        getMean = xform1 c_th2poly_getmean
        getMeanError = xform1 c_th2poly_getmeanerror
        getNbinsX = xform0 c_th2poly_getnbinsx
        getNbinsY = xform0 c_th2poly_getnbinsy
        getNbinsZ = xform0 c_th2poly_getnbinsz
        getQuantilesTH1 = xform3 c_th2poly_getquantilesth1
        getRandom = xform0 c_th2poly_getrandom
        getStats = xform1 c_th2poly_getstats
        getSumOfWeights = xform0 c_th2poly_getsumofweights
        getSumw2 = xform0 c_th2poly_getsumw2
        getSumw2N = xform0 c_th2poly_getsumw2n
        getRMS = xform1 c_th2poly_getrms
        getRMSError = xform1 c_th2poly_getrmserror
        getSkewness = xform1 c_th2poly_getskewness
        integral1 = xform3 c_th2poly_integral1
        interpolate1 = xform1 c_th2poly_interpolate1
        interpolate2 = xform2 c_th2poly_interpolate2
        interpolate3 = xform3 c_th2poly_interpolate3
        kolmogorovTest = xform2 c_th2poly_kolmogorovtest
        labelsDeflate = xform1 c_th2poly_labelsdeflate
        labelsInflate = xform1 c_th2poly_labelsinflate
        labelsOption = xform2 c_th2poly_labelsoption
        multiflyF = xform2 c_th2poly_multiflyf
        multiply = xform5 c_th2poly_multiply
        putStats = xform1 c_th2poly_putstats
        rebin = xform3 c_th2poly_rebin
        rebinAxis = xform2 c_th2poly_rebinaxis
        rebuild = xform1 c_th2poly_rebuild
        recursiveRemove = xform1 c_th2poly_recursiveremove
        reset = xform1 c_th2poly_reset
        resetStats = xform0 c_th2poly_resetstats
        scale = xform2 c_th2poly_scale
        setAxisColorA = xform2 c_th2poly_setaxiscolora
        setAxisRange = xform3 c_th2poly_setaxisrange
        setBarOffset = xform1 c_th2poly_setbaroffset
        setBarWidth = xform1 c_th2poly_setbarwidth
        setBinContent1 = xform2 c_th2poly_setbincontent1
        setBinContent2 = xform3 c_th2poly_setbincontent2
        setBinContent3 = xform4 c_th2poly_setbincontent3
        setBinError1 = xform2 c_th2poly_setbinerror1
        setBinError2 = xform3 c_th2poly_setbinerror2
        setBinError3 = xform4 c_th2poly_setbinerror3
        setBins1 = xform2 c_th2poly_setbins1
        setBins2 = xform4 c_th2poly_setbins2
        setBins3 = xform6 c_th2poly_setbins3
        setBinsLength = xform1 c_th2poly_setbinslength
        setBuffer = xform2 c_th2poly_setbuffer
        setCellContent = xform3 c_th2poly_setcellcontent
        setContent = xform1 c_th2poly_setcontent
        setContour = xform2 c_th2poly_setcontour
        setContourLevel = xform2 c_th2poly_setcontourlevel
        setDirectory = xform1 c_th2poly_setdirectory
        setEntries = xform1 c_th2poly_setentries
        setError = xform1 c_th2poly_seterror
        setLabelColorA = xform2 c_th2poly_setlabelcolora
        setLabelSizeA = xform2 c_th2poly_setlabelsizea
        setLabelFontA = xform2 c_th2poly_setlabelfonta
        setLabelOffsetA = xform2 c_th2poly_setlabeloffseta
        setMaximum = xform1 c_th2poly_setmaximum
        setMinimum = xform1 c_th2poly_setminimum
        setNormFactor = xform1 c_th2poly_setnormfactor
        setStats = xform1 c_th2poly_setstats
        setOption = xform1 c_th2poly_setoption
        setXTitle = xform1 c_th2poly_setxtitle
        setYTitle = xform1 c_th2poly_setytitle
        setZTitle = xform1 c_th2poly_setztitle
        showBackground = xform2 c_th2poly_showbackground
        showPeaks = xform3 c_th2poly_showpeaks
        smooth = xform2 c_th2poly_smooth
        sumw2 = xform0 c_th2poly_sumw2

instance ITNamed TH2Poly where
        setName = xform1 c_th2poly_setname
        setNameTitle = xform2 c_th2poly_setnametitle
        setTitle = xform1 c_th2poly_settitle

instance ITAttLine TH2Poly where
        getLineColor = xform0 c_th2poly_getlinecolor
        getLineStyle = xform0 c_th2poly_getlinestyle
        getLineWidth = xform0 c_th2poly_getlinewidth
        resetAttLine = xform1 c_th2poly_resetattline
        setLineAttributes = xform0 c_th2poly_setlineattributes
        setLineColor = xform1 c_th2poly_setlinecolor
        setLineStyle = xform1 c_th2poly_setlinestyle
        setLineWidth = xform1 c_th2poly_setlinewidth

instance ITAttFill TH2Poly where
        setFillColor = xform1 c_th2poly_setfillcolor
        setFillStyle = xform1 c_th2poly_setfillstyle

instance ITAttMarker TH2Poly where
        getMarkerColor = xform0 c_th2poly_getmarkercolor
        getMarkerStyle = xform0 c_th2poly_getmarkerstyle
        getMarkerSize = xform0 c_th2poly_getmarkersize
        resetAttMarker = xform1 c_th2poly_resetattmarker
        setMarkerAttributes = xform0 c_th2poly_setmarkerattributes
        setMarkerColor = xform1 c_th2poly_setmarkercolor
        setMarkerStyle = xform1 c_th2poly_setmarkerstyle
        setMarkerSize = xform1 c_th2poly_setmarkersize

instance ITObject TH2Poly where
        draw = xform1 c_th2poly_draw
        findObject = xform1 c_th2poly_findobject
        getName = xform0 c_th2poly_getname
        isA = xform0 c_th2poly_isa
        paint = xform1 c_th2poly_paint
        printObj = xform1 c_th2poly_printobj
        saveAs = xform2 c_th2poly_saveas
        write = xform3 c_th2poly_write

instance IDeletable TH2Poly where
        delete = xform0 c_th2poly_delete
