{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2S.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH2S.RawType
import HROOT.Hist.TH2S.FFI
import HROOT.Hist.TH2S.Interface
import HROOT.Hist.TH2S.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayS.RawType
import HROOT.Core.TArrayS.Cast
import HROOT.Core.TArrayS.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH2S TH2S

instance ITH2 TH2S where
        fill2 = xform2 c_th2s_fill2
        fill2w = xform3 c_th2s_fill2w
        fillN2 = xform5 c_th2s_filln2
        fillRandom2 = xform2 c_th2s_fillrandom2
        findFirstBinAbove2 = xform2 c_th2s_findfirstbinabove2
        findLastBinAbove2 = xform2 c_th2s_findlastbinabove2
        fitSlicesX = xform6 c_th2s_fitslicesx
        fitSlicesY = xform6 c_th2s_fitslicesy
        getCorrelationFactor2 = xform2 c_th2s_getcorrelationfactor2
        getCovariance2 = xform2 c_th2s_getcovariance2
        integral2 = xform5 c_th2s_integral2
        rebinX2 = xform2 c_th2s_rebinx2
        rebinY2 = xform2 c_th2s_rebiny2
        rebin2D = xform3 c_th2s_rebin2d
        setShowProjectionX = xform1 c_th2s_setshowprojectionx
        setShowProjectionY = xform1 c_th2s_setshowprojectiony

instance ITArrayS TH2S

instance ITH1 TH2S where
        add = xform2 c_th2s_add
        addBinContent = xform2 c_th2s_addbincontent
        chi2Test = xform3 c_th2s_chi2test
        computeIntegral = xform0 c_th2s_computeintegral
        directoryAutoAdd = xform1 c_th2s_directoryautoadd
        divide = xform5 c_th2s_divide
        drawCopyTH1 = xform1 c_th2s_drawcopyth1
        drawNormalized = xform2 c_th2s_drawnormalized
        drawPanelTH1 = xform0 c_th2s_drawpanelth1
        bufferEmpty = xform1 c_th2s_bufferempty
        evalF = xform2 c_th2s_evalf
        fFT = xform2 c_th2s_fft
        fill1 = xform1 c_th2s_fill1
        fill1w = xform2 c_th2s_fill1w
        fillN1 = xform4 c_th2s_filln1
        fillRandom = xform2 c_th2s_fillrandom
        findBin = xform3 c_th2s_findbin
        findFixBin = xform3 c_th2s_findfixbin
        findFirstBinAbove = xform2 c_th2s_findfirstbinabove
        findLastBinAbove = xform2 c_th2s_findlastbinabove
        fit = xform5 c_th2s_fit
        fitPanelTH1 = xform0 c_th2s_fitpanelth1
        getNdivisionA = xform1 c_th2s_getndivisiona
        getAxisColorA = xform1 c_th2s_getaxiscolora
        getLabelColorA = xform1 c_th2s_getlabelcolora
        getLabelFontA = xform1 c_th2s_getlabelfonta
        getLabelOffsetA = xform1 c_th2s_getlabeloffseta
        getLabelSizeA = xform1 c_th2s_getlabelsizea
        getTitleFontA = xform1 c_th2s_gettitlefonta
        getTitleOffsetA = xform1 c_th2s_gettitleoffseta
        getTitleSizeA = xform1 c_th2s_gettitlesizea
        getTickLengthA = xform1 c_th2s_getticklengtha
        getBarOffset = xform0 c_th2s_getbaroffset
        getBarWidth = xform0 c_th2s_getbarwidth
        getContour = xform1 c_th2s_getcontour
        getContourLevel = xform1 c_th2s_getcontourlevel
        getContourLevelPad = xform1 c_th2s_getcontourlevelpad
        getBin = xform3 c_th2s_getbin
        getBinCenter = xform1 c_th2s_getbincenter
        getBinContent1 = xform1 c_th2s_getbincontent1
        getBinContent2 = xform2 c_th2s_getbincontent2
        getBinContent3 = xform3 c_th2s_getbincontent3
        getBinError1 = xform1 c_th2s_getbinerror1
        getBinError2 = xform2 c_th2s_getbinerror2
        getBinError3 = xform3 c_th2s_getbinerror3
        getBinLowEdge = xform1 c_th2s_getbinlowedge
        getBinWidth = xform1 c_th2s_getbinwidth
        getCellContent = xform2 c_th2s_getcellcontent
        getCellError = xform2 c_th2s_getcellerror
        getEntries = xform0 c_th2s_getentries
        getEffectiveEntries = xform0 c_th2s_geteffectiveentries
        getFunction = xform1 c_th2s_getfunction
        getDimension = xform0 c_th2s_getdimension
        getKurtosis = xform1 c_th2s_getkurtosis
        getLowEdge = xform1 c_th2s_getlowedge
        getMaximumTH1 = xform1 c_th2s_getmaximumth1
        getMaximumBin = xform0 c_th2s_getmaximumbin
        getMaximumStored = xform0 c_th2s_getmaximumstored
        getMinimumTH1 = xform1 c_th2s_getminimumth1
        getMinimumBin = xform0 c_th2s_getminimumbin
        getMinimumStored = xform0 c_th2s_getminimumstored
        getMean = xform1 c_th2s_getmean
        getMeanError = xform1 c_th2s_getmeanerror
        getNbinsX = xform0 c_th2s_getnbinsx
        getNbinsY = xform0 c_th2s_getnbinsy
        getNbinsZ = xform0 c_th2s_getnbinsz
        getQuantilesTH1 = xform3 c_th2s_getquantilesth1
        getRandom = xform0 c_th2s_getrandom
        getStats = xform1 c_th2s_getstats
        getSumOfWeights = xform0 c_th2s_getsumofweights
        getSumw2 = xform0 c_th2s_getsumw2
        getSumw2N = xform0 c_th2s_getsumw2n
        getRMS = xform1 c_th2s_getrms
        getRMSError = xform1 c_th2s_getrmserror
        getSkewness = xform1 c_th2s_getskewness
        integral1 = xform3 c_th2s_integral1
        interpolate1 = xform1 c_th2s_interpolate1
        interpolate2 = xform2 c_th2s_interpolate2
        interpolate3 = xform3 c_th2s_interpolate3
        kolmogorovTest = xform2 c_th2s_kolmogorovtest
        labelsDeflate = xform1 c_th2s_labelsdeflate
        labelsInflate = xform1 c_th2s_labelsinflate
        labelsOption = xform2 c_th2s_labelsoption
        multiflyF = xform2 c_th2s_multiflyf
        multiply = xform5 c_th2s_multiply
        putStats = xform1 c_th2s_putstats
        rebin = xform3 c_th2s_rebin
        rebinAxis = xform2 c_th2s_rebinaxis
        rebuild = xform1 c_th2s_rebuild
        recursiveRemove = xform1 c_th2s_recursiveremove
        reset = xform1 c_th2s_reset
        resetStats = xform0 c_th2s_resetstats
        scale = xform2 c_th2s_scale
        setAxisColorA = xform2 c_th2s_setaxiscolora
        setAxisRange = xform3 c_th2s_setaxisrange
        setBarOffset = xform1 c_th2s_setbaroffset
        setBarWidth = xform1 c_th2s_setbarwidth
        setBinContent1 = xform2 c_th2s_setbincontent1
        setBinContent2 = xform3 c_th2s_setbincontent2
        setBinContent3 = xform4 c_th2s_setbincontent3
        setBinError1 = xform2 c_th2s_setbinerror1
        setBinError2 = xform3 c_th2s_setbinerror2
        setBinError3 = xform4 c_th2s_setbinerror3
        setBins1 = xform2 c_th2s_setbins1
        setBins2 = xform4 c_th2s_setbins2
        setBins3 = xform6 c_th2s_setbins3
        setBinsLength = xform1 c_th2s_setbinslength
        setBuffer = xform2 c_th2s_setbuffer
        setCellContent = xform3 c_th2s_setcellcontent
        setContent = xform1 c_th2s_setcontent
        setContour = xform2 c_th2s_setcontour
        setContourLevel = xform2 c_th2s_setcontourlevel
        setDirectory = xform1 c_th2s_setdirectory
        setEntries = xform1 c_th2s_setentries
        setError = xform1 c_th2s_seterror
        setLabelColorA = xform2 c_th2s_setlabelcolora
        setLabelSizeA = xform2 c_th2s_setlabelsizea
        setLabelFontA = xform2 c_th2s_setlabelfonta
        setLabelOffsetA = xform2 c_th2s_setlabeloffseta
        setMaximum = xform1 c_th2s_setmaximum
        setMinimum = xform1 c_th2s_setminimum
        setNormFactor = xform1 c_th2s_setnormfactor
        setStats = xform1 c_th2s_setstats
        setOption = xform1 c_th2s_setoption
        setXTitle = xform1 c_th2s_setxtitle
        setYTitle = xform1 c_th2s_setytitle
        setZTitle = xform1 c_th2s_setztitle
        showBackground = xform2 c_th2s_showbackground
        showPeaks = xform3 c_th2s_showpeaks
        smooth = xform2 c_th2s_smooth
        sumw2 = xform0 c_th2s_sumw2

instance ITNamed TH2S where
        setName = xform1 c_th2s_setname
        setNameTitle = xform2 c_th2s_setnametitle
        setTitle = xform1 c_th2s_settitle

instance ITAttLine TH2S where
        getLineColor = xform0 c_th2s_getlinecolor
        getLineStyle = xform0 c_th2s_getlinestyle
        getLineWidth = xform0 c_th2s_getlinewidth
        resetAttLine = xform1 c_th2s_resetattline
        setLineAttributes = xform0 c_th2s_setlineattributes
        setLineColor = xform1 c_th2s_setlinecolor
        setLineStyle = xform1 c_th2s_setlinestyle
        setLineWidth = xform1 c_th2s_setlinewidth

instance ITAttFill TH2S where
        setFillColor = xform1 c_th2s_setfillcolor
        setFillStyle = xform1 c_th2s_setfillstyle

instance ITAttMarker TH2S where
        getMarkerColor = xform0 c_th2s_getmarkercolor
        getMarkerStyle = xform0 c_th2s_getmarkerstyle
        getMarkerSize = xform0 c_th2s_getmarkersize
        resetAttMarker = xform1 c_th2s_resetattmarker
        setMarkerAttributes = xform0 c_th2s_setmarkerattributes
        setMarkerColor = xform1 c_th2s_setmarkercolor
        setMarkerStyle = xform1 c_th2s_setmarkerstyle
        setMarkerSize = xform1 c_th2s_setmarkersize

instance ITObject TH2S where
        draw = xform1 c_th2s_draw
        findObject = xform1 c_th2s_findobject
        getName = xform0 c_th2s_getname
        isA = xform0 c_th2s_isa
        paint = xform1 c_th2s_paint
        printObj = xform1 c_th2s_printobj
        saveAs = xform2 c_th2s_saveas
        write = xform3 c_th2s_write

instance IDeletable TH2S where
        delete = xform0 c_th2s_delete

instance ITArray TH2S
