{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3C.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH3C.RawType
import HROOT.Hist.TH3C.FFI
import HROOT.Hist.TH3C.Interface
import HROOT.Hist.TH3C.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH3.RawType
import HROOT.Hist.TH3.Cast
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayC.RawType
import HROOT.Core.TArrayC.Cast
import HROOT.Core.TArrayC.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH3C TH3C

instance ITH3 TH3C where
        fill3 = xform3 c_th3c_fill3
        fill3w = xform4 c_th3c_fill3w
        fitSlicesZ = xform7 c_th3c_fitslicesz
        getCorrelationFactor3 = xform2 c_th3c_getcorrelationfactor3
        getCovariance3 = xform2 c_th3c_getcovariance3
        rebinX3 = xform2 c_th3c_rebinx3
        rebinY3 = xform2 c_th3c_rebiny3
        rebinZ3 = xform2 c_th3c_rebinz3
        rebin3D = xform4 c_th3c_rebin3d

instance ITArrayC TH3C

instance ITH1 TH3C where
        add = xform2 c_th3c_add
        addBinContent = xform2 c_th3c_addbincontent
        chi2Test = xform3 c_th3c_chi2test
        computeIntegral = xform0 c_th3c_computeintegral
        directoryAutoAdd = xform1 c_th3c_directoryautoadd
        divide = xform5 c_th3c_divide
        drawCopyTH1 = xform1 c_th3c_drawcopyth1
        drawNormalized = xform2 c_th3c_drawnormalized
        drawPanelTH1 = xform0 c_th3c_drawpanelth1
        bufferEmpty = xform1 c_th3c_bufferempty
        evalF = xform2 c_th3c_evalf
        fFT = xform2 c_th3c_fft
        fill1 = xform1 c_th3c_fill1
        fill1w = xform2 c_th3c_fill1w
        fillN1 = xform4 c_th3c_filln1
        fillRandom = xform2 c_th3c_fillrandom
        findBin = xform3 c_th3c_findbin
        findFixBin = xform3 c_th3c_findfixbin
        findFirstBinAbove = xform2 c_th3c_findfirstbinabove
        findLastBinAbove = xform2 c_th3c_findlastbinabove
        fit = xform5 c_th3c_fit
        fitPanelTH1 = xform0 c_th3c_fitpanelth1
        getNdivisionA = xform1 c_th3c_getndivisiona
        getAxisColorA = xform1 c_th3c_getaxiscolora
        getLabelColorA = xform1 c_th3c_getlabelcolora
        getLabelFontA = xform1 c_th3c_getlabelfonta
        getLabelOffsetA = xform1 c_th3c_getlabeloffseta
        getLabelSizeA = xform1 c_th3c_getlabelsizea
        getTitleFontA = xform1 c_th3c_gettitlefonta
        getTitleOffsetA = xform1 c_th3c_gettitleoffseta
        getTitleSizeA = xform1 c_th3c_gettitlesizea
        getTickLengthA = xform1 c_th3c_getticklengtha
        getBarOffset = xform0 c_th3c_getbaroffset
        getBarWidth = xform0 c_th3c_getbarwidth
        getContour = xform1 c_th3c_getcontour
        getContourLevel = xform1 c_th3c_getcontourlevel
        getContourLevelPad = xform1 c_th3c_getcontourlevelpad
        getBin = xform3 c_th3c_getbin
        getBinCenter = xform1 c_th3c_getbincenter
        getBinContent1 = xform1 c_th3c_getbincontent1
        getBinContent2 = xform2 c_th3c_getbincontent2
        getBinContent3 = xform3 c_th3c_getbincontent3
        getBinError1 = xform1 c_th3c_getbinerror1
        getBinError2 = xform2 c_th3c_getbinerror2
        getBinError3 = xform3 c_th3c_getbinerror3
        getBinLowEdge = xform1 c_th3c_getbinlowedge
        getBinWidth = xform1 c_th3c_getbinwidth
        getCellContent = xform2 c_th3c_getcellcontent
        getCellError = xform2 c_th3c_getcellerror
        getEntries = xform0 c_th3c_getentries
        getEffectiveEntries = xform0 c_th3c_geteffectiveentries
        getFunction = xform1 c_th3c_getfunction
        getDimension = xform0 c_th3c_getdimension
        getKurtosis = xform1 c_th3c_getkurtosis
        getLowEdge = xform1 c_th3c_getlowedge
        getMaximumTH1 = xform1 c_th3c_getmaximumth1
        getMaximumBin = xform0 c_th3c_getmaximumbin
        getMaximumStored = xform0 c_th3c_getmaximumstored
        getMinimumTH1 = xform1 c_th3c_getminimumth1
        getMinimumBin = xform0 c_th3c_getminimumbin
        getMinimumStored = xform0 c_th3c_getminimumstored
        getMean = xform1 c_th3c_getmean
        getMeanError = xform1 c_th3c_getmeanerror
        getNbinsX = xform0 c_th3c_getnbinsx
        getNbinsY = xform0 c_th3c_getnbinsy
        getNbinsZ = xform0 c_th3c_getnbinsz
        getQuantilesTH1 = xform3 c_th3c_getquantilesth1
        getRandom = xform0 c_th3c_getrandom
        getStats = xform1 c_th3c_getstats
        getSumOfWeights = xform0 c_th3c_getsumofweights
        getSumw2 = xform0 c_th3c_getsumw2
        getSumw2N = xform0 c_th3c_getsumw2n
        getRMS = xform1 c_th3c_getrms
        getRMSError = xform1 c_th3c_getrmserror
        getSkewness = xform1 c_th3c_getskewness
        integral1 = xform3 c_th3c_integral1
        interpolate1 = xform1 c_th3c_interpolate1
        interpolate2 = xform2 c_th3c_interpolate2
        interpolate3 = xform3 c_th3c_interpolate3
        kolmogorovTest = xform2 c_th3c_kolmogorovtest
        labelsDeflate = xform1 c_th3c_labelsdeflate
        labelsInflate = xform1 c_th3c_labelsinflate
        labelsOption = xform2 c_th3c_labelsoption
        multiflyF = xform2 c_th3c_multiflyf
        multiply = xform5 c_th3c_multiply
        putStats = xform1 c_th3c_putstats
        rebin = xform3 c_th3c_rebin
        rebinAxis = xform2 c_th3c_rebinaxis
        rebuild = xform1 c_th3c_rebuild
        recursiveRemove = xform1 c_th3c_recursiveremove
        reset = xform1 c_th3c_reset
        resetStats = xform0 c_th3c_resetstats
        scale = xform2 c_th3c_scale
        setAxisColorA = xform2 c_th3c_setaxiscolora
        setAxisRange = xform3 c_th3c_setaxisrange
        setBarOffset = xform1 c_th3c_setbaroffset
        setBarWidth = xform1 c_th3c_setbarwidth
        setBinContent1 = xform2 c_th3c_setbincontent1
        setBinContent2 = xform3 c_th3c_setbincontent2
        setBinContent3 = xform4 c_th3c_setbincontent3
        setBinError1 = xform2 c_th3c_setbinerror1
        setBinError2 = xform3 c_th3c_setbinerror2
        setBinError3 = xform4 c_th3c_setbinerror3
        setBins1 = xform2 c_th3c_setbins1
        setBins2 = xform4 c_th3c_setbins2
        setBins3 = xform6 c_th3c_setbins3
        setBinsLength = xform1 c_th3c_setbinslength
        setBuffer = xform2 c_th3c_setbuffer
        setCellContent = xform3 c_th3c_setcellcontent
        setContent = xform1 c_th3c_setcontent
        setContour = xform2 c_th3c_setcontour
        setContourLevel = xform2 c_th3c_setcontourlevel
        setDirectory = xform1 c_th3c_setdirectory
        setEntries = xform1 c_th3c_setentries
        setError = xform1 c_th3c_seterror
        setLabelColorA = xform2 c_th3c_setlabelcolora
        setLabelSizeA = xform2 c_th3c_setlabelsizea
        setLabelFontA = xform2 c_th3c_setlabelfonta
        setLabelOffsetA = xform2 c_th3c_setlabeloffseta
        setMaximum = xform1 c_th3c_setmaximum
        setMinimum = xform1 c_th3c_setminimum
        setNormFactor = xform1 c_th3c_setnormfactor
        setStats = xform1 c_th3c_setstats
        setOption = xform1 c_th3c_setoption
        setXTitle = xform1 c_th3c_setxtitle
        setYTitle = xform1 c_th3c_setytitle
        setZTitle = xform1 c_th3c_setztitle
        showBackground = xform2 c_th3c_showbackground
        showPeaks = xform3 c_th3c_showpeaks
        smooth = xform2 c_th3c_smooth
        sumw2 = xform0 c_th3c_sumw2

instance ITAtt3D TH3C

instance ITNamed TH3C where
        setName = xform1 c_th3c_setname
        setNameTitle = xform2 c_th3c_setnametitle
        setTitle = xform1 c_th3c_settitle

instance ITAttLine TH3C where
        getLineColor = xform0 c_th3c_getlinecolor
        getLineStyle = xform0 c_th3c_getlinestyle
        getLineWidth = xform0 c_th3c_getlinewidth
        resetAttLine = xform1 c_th3c_resetattline
        setLineAttributes = xform0 c_th3c_setlineattributes
        setLineColor = xform1 c_th3c_setlinecolor
        setLineStyle = xform1 c_th3c_setlinestyle
        setLineWidth = xform1 c_th3c_setlinewidth

instance ITAttFill TH3C where
        setFillColor = xform1 c_th3c_setfillcolor
        setFillStyle = xform1 c_th3c_setfillstyle

instance ITAttMarker TH3C where
        getMarkerColor = xform0 c_th3c_getmarkercolor
        getMarkerStyle = xform0 c_th3c_getmarkerstyle
        getMarkerSize = xform0 c_th3c_getmarkersize
        resetAttMarker = xform1 c_th3c_resetattmarker
        setMarkerAttributes = xform0 c_th3c_setmarkerattributes
        setMarkerColor = xform1 c_th3c_setmarkercolor
        setMarkerStyle = xform1 c_th3c_setmarkerstyle
        setMarkerSize = xform1 c_th3c_setmarkersize

instance ITObject TH3C where
        draw = xform1 c_th3c_draw
        findObject = xform1 c_th3c_findobject
        getName = xform0 c_th3c_getname
        isA = xform0 c_th3c_isa
        paint = xform1 c_th3c_paint
        printObj = xform1 c_th3c_printobj
        saveAs = xform2 c_th3c_saveas
        write = xform3 c_th3c_write

instance IDeletable TH3C where
        delete = xform0 c_th3c_delete

instance ITArray TH3C
