{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3D.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH3D.RawType
import HROOT.Hist.TH3D.FFI
import HROOT.Hist.TH3D.Interface
import HROOT.Hist.TH3D.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH3.RawType
import HROOT.Hist.TH3.Cast
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH3D TH3D

instance ITH3 TH3D where
        fill3 = xform3 c_th3d_fill3
        fill3w = xform4 c_th3d_fill3w
        fitSlicesZ = xform7 c_th3d_fitslicesz
        getCorrelationFactor3 = xform2 c_th3d_getcorrelationfactor3
        getCovariance3 = xform2 c_th3d_getcovariance3
        rebinX3 = xform2 c_th3d_rebinx3
        rebinY3 = xform2 c_th3d_rebiny3
        rebinZ3 = xform2 c_th3d_rebinz3
        rebin3D = xform4 c_th3d_rebin3d

instance ITArrayD TH3D

instance ITH1 TH3D where
        add = xform2 c_th3d_add
        addBinContent = xform2 c_th3d_addbincontent
        chi2Test = xform3 c_th3d_chi2test
        computeIntegral = xform0 c_th3d_computeintegral
        directoryAutoAdd = xform1 c_th3d_directoryautoadd
        divide = xform5 c_th3d_divide
        drawCopyTH1 = xform1 c_th3d_drawcopyth1
        drawNormalized = xform2 c_th3d_drawnormalized
        drawPanelTH1 = xform0 c_th3d_drawpanelth1
        bufferEmpty = xform1 c_th3d_bufferempty
        evalF = xform2 c_th3d_evalf
        fFT = xform2 c_th3d_fft
        fill1 = xform1 c_th3d_fill1
        fill1w = xform2 c_th3d_fill1w
        fillN1 = xform4 c_th3d_filln1
        fillRandom = xform2 c_th3d_fillrandom
        findBin = xform3 c_th3d_findbin
        findFixBin = xform3 c_th3d_findfixbin
        findFirstBinAbove = xform2 c_th3d_findfirstbinabove
        findLastBinAbove = xform2 c_th3d_findlastbinabove
        fit = xform5 c_th3d_fit
        fitPanelTH1 = xform0 c_th3d_fitpanelth1
        getNdivisionA = xform1 c_th3d_getndivisiona
        getAxisColorA = xform1 c_th3d_getaxiscolora
        getLabelColorA = xform1 c_th3d_getlabelcolora
        getLabelFontA = xform1 c_th3d_getlabelfonta
        getLabelOffsetA = xform1 c_th3d_getlabeloffseta
        getLabelSizeA = xform1 c_th3d_getlabelsizea
        getTitleFontA = xform1 c_th3d_gettitlefonta
        getTitleOffsetA = xform1 c_th3d_gettitleoffseta
        getTitleSizeA = xform1 c_th3d_gettitlesizea
        getTickLengthA = xform1 c_th3d_getticklengtha
        getBarOffset = xform0 c_th3d_getbaroffset
        getBarWidth = xform0 c_th3d_getbarwidth
        getContour = xform1 c_th3d_getcontour
        getContourLevel = xform1 c_th3d_getcontourlevel
        getContourLevelPad = xform1 c_th3d_getcontourlevelpad
        getBin = xform3 c_th3d_getbin
        getBinCenter = xform1 c_th3d_getbincenter
        getBinContent1 = xform1 c_th3d_getbincontent1
        getBinContent2 = xform2 c_th3d_getbincontent2
        getBinContent3 = xform3 c_th3d_getbincontent3
        getBinError1 = xform1 c_th3d_getbinerror1
        getBinError2 = xform2 c_th3d_getbinerror2
        getBinError3 = xform3 c_th3d_getbinerror3
        getBinLowEdge = xform1 c_th3d_getbinlowedge
        getBinWidth = xform1 c_th3d_getbinwidth
        getCellContent = xform2 c_th3d_getcellcontent
        getCellError = xform2 c_th3d_getcellerror
        getEntries = xform0 c_th3d_getentries
        getEffectiveEntries = xform0 c_th3d_geteffectiveentries
        getFunction = xform1 c_th3d_getfunction
        getDimension = xform0 c_th3d_getdimension
        getKurtosis = xform1 c_th3d_getkurtosis
        getLowEdge = xform1 c_th3d_getlowedge
        getMaximumTH1 = xform1 c_th3d_getmaximumth1
        getMaximumBin = xform0 c_th3d_getmaximumbin
        getMaximumStored = xform0 c_th3d_getmaximumstored
        getMinimumTH1 = xform1 c_th3d_getminimumth1
        getMinimumBin = xform0 c_th3d_getminimumbin
        getMinimumStored = xform0 c_th3d_getminimumstored
        getMean = xform1 c_th3d_getmean
        getMeanError = xform1 c_th3d_getmeanerror
        getNbinsX = xform0 c_th3d_getnbinsx
        getNbinsY = xform0 c_th3d_getnbinsy
        getNbinsZ = xform0 c_th3d_getnbinsz
        getQuantilesTH1 = xform3 c_th3d_getquantilesth1
        getRandom = xform0 c_th3d_getrandom
        getStats = xform1 c_th3d_getstats
        getSumOfWeights = xform0 c_th3d_getsumofweights
        getSumw2 = xform0 c_th3d_getsumw2
        getSumw2N = xform0 c_th3d_getsumw2n
        getRMS = xform1 c_th3d_getrms
        getRMSError = xform1 c_th3d_getrmserror
        getSkewness = xform1 c_th3d_getskewness
        integral1 = xform3 c_th3d_integral1
        interpolate1 = xform1 c_th3d_interpolate1
        interpolate2 = xform2 c_th3d_interpolate2
        interpolate3 = xform3 c_th3d_interpolate3
        kolmogorovTest = xform2 c_th3d_kolmogorovtest
        labelsDeflate = xform1 c_th3d_labelsdeflate
        labelsInflate = xform1 c_th3d_labelsinflate
        labelsOption = xform2 c_th3d_labelsoption
        multiflyF = xform2 c_th3d_multiflyf
        multiply = xform5 c_th3d_multiply
        putStats = xform1 c_th3d_putstats
        rebin = xform3 c_th3d_rebin
        rebinAxis = xform2 c_th3d_rebinaxis
        rebuild = xform1 c_th3d_rebuild
        recursiveRemove = xform1 c_th3d_recursiveremove
        reset = xform1 c_th3d_reset
        resetStats = xform0 c_th3d_resetstats
        scale = xform2 c_th3d_scale
        setAxisColorA = xform2 c_th3d_setaxiscolora
        setAxisRange = xform3 c_th3d_setaxisrange
        setBarOffset = xform1 c_th3d_setbaroffset
        setBarWidth = xform1 c_th3d_setbarwidth
        setBinContent1 = xform2 c_th3d_setbincontent1
        setBinContent2 = xform3 c_th3d_setbincontent2
        setBinContent3 = xform4 c_th3d_setbincontent3
        setBinError1 = xform2 c_th3d_setbinerror1
        setBinError2 = xform3 c_th3d_setbinerror2
        setBinError3 = xform4 c_th3d_setbinerror3
        setBins1 = xform2 c_th3d_setbins1
        setBins2 = xform4 c_th3d_setbins2
        setBins3 = xform6 c_th3d_setbins3
        setBinsLength = xform1 c_th3d_setbinslength
        setBuffer = xform2 c_th3d_setbuffer
        setCellContent = xform3 c_th3d_setcellcontent
        setContent = xform1 c_th3d_setcontent
        setContour = xform2 c_th3d_setcontour
        setContourLevel = xform2 c_th3d_setcontourlevel
        setDirectory = xform1 c_th3d_setdirectory
        setEntries = xform1 c_th3d_setentries
        setError = xform1 c_th3d_seterror
        setLabelColorA = xform2 c_th3d_setlabelcolora
        setLabelSizeA = xform2 c_th3d_setlabelsizea
        setLabelFontA = xform2 c_th3d_setlabelfonta
        setLabelOffsetA = xform2 c_th3d_setlabeloffseta
        setMaximum = xform1 c_th3d_setmaximum
        setMinimum = xform1 c_th3d_setminimum
        setNormFactor = xform1 c_th3d_setnormfactor
        setStats = xform1 c_th3d_setstats
        setOption = xform1 c_th3d_setoption
        setXTitle = xform1 c_th3d_setxtitle
        setYTitle = xform1 c_th3d_setytitle
        setZTitle = xform1 c_th3d_setztitle
        showBackground = xform2 c_th3d_showbackground
        showPeaks = xform3 c_th3d_showpeaks
        smooth = xform2 c_th3d_smooth
        sumw2 = xform0 c_th3d_sumw2

instance ITAtt3D TH3D

instance ITNamed TH3D where
        setName = xform1 c_th3d_setname
        setNameTitle = xform2 c_th3d_setnametitle
        setTitle = xform1 c_th3d_settitle

instance ITAttLine TH3D where
        getLineColor = xform0 c_th3d_getlinecolor
        getLineStyle = xform0 c_th3d_getlinestyle
        getLineWidth = xform0 c_th3d_getlinewidth
        resetAttLine = xform1 c_th3d_resetattline
        setLineAttributes = xform0 c_th3d_setlineattributes
        setLineColor = xform1 c_th3d_setlinecolor
        setLineStyle = xform1 c_th3d_setlinestyle
        setLineWidth = xform1 c_th3d_setlinewidth

instance ITAttFill TH3D where
        setFillColor = xform1 c_th3d_setfillcolor
        setFillStyle = xform1 c_th3d_setfillstyle

instance ITAttMarker TH3D where
        getMarkerColor = xform0 c_th3d_getmarkercolor
        getMarkerStyle = xform0 c_th3d_getmarkerstyle
        getMarkerSize = xform0 c_th3d_getmarkersize
        resetAttMarker = xform1 c_th3d_resetattmarker
        setMarkerAttributes = xform0 c_th3d_setmarkerattributes
        setMarkerColor = xform1 c_th3d_setmarkercolor
        setMarkerStyle = xform1 c_th3d_setmarkerstyle
        setMarkerSize = xform1 c_th3d_setmarkersize

instance ITObject TH3D where
        draw = xform1 c_th3d_draw
        findObject = xform1 c_th3d_findobject
        getName = xform0 c_th3d_getname
        isA = xform0 c_th3d_isa
        paint = xform1 c_th3d_paint
        printObj = xform1 c_th3d_printobj
        saveAs = xform2 c_th3d_saveas
        write = xform3 c_th3d_write

instance IDeletable TH3D where
        delete = xform0 c_th3d_delete

instance ITArray TH3D
