{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3S.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH3S.RawType
import HROOT.Hist.TH3S.FFI
import HROOT.Hist.TH3S.Interface
import HROOT.Hist.TH3S.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH3.RawType
import HROOT.Hist.TH3.Cast
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayS.RawType
import HROOT.Core.TArrayS.Cast
import HROOT.Core.TArrayS.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH3S TH3S

instance ITH3 TH3S where
        fill3 = xform3 c_th3s_fill3
        fill3w = xform4 c_th3s_fill3w
        fitSlicesZ = xform7 c_th3s_fitslicesz
        getCorrelationFactor3 = xform2 c_th3s_getcorrelationfactor3
        getCovariance3 = xform2 c_th3s_getcovariance3
        rebinX3 = xform2 c_th3s_rebinx3
        rebinY3 = xform2 c_th3s_rebiny3
        rebinZ3 = xform2 c_th3s_rebinz3
        rebin3D = xform4 c_th3s_rebin3d

instance ITArrayS TH3S

instance ITH1 TH3S where
        add = xform2 c_th3s_add
        addBinContent = xform2 c_th3s_addbincontent
        chi2Test = xform3 c_th3s_chi2test
        computeIntegral = xform0 c_th3s_computeintegral
        directoryAutoAdd = xform1 c_th3s_directoryautoadd
        divide = xform5 c_th3s_divide
        drawCopyTH1 = xform1 c_th3s_drawcopyth1
        drawNormalized = xform2 c_th3s_drawnormalized
        drawPanelTH1 = xform0 c_th3s_drawpanelth1
        bufferEmpty = xform1 c_th3s_bufferempty
        evalF = xform2 c_th3s_evalf
        fFT = xform2 c_th3s_fft
        fill1 = xform1 c_th3s_fill1
        fill1w = xform2 c_th3s_fill1w
        fillN1 = xform4 c_th3s_filln1
        fillRandom = xform2 c_th3s_fillrandom
        findBin = xform3 c_th3s_findbin
        findFixBin = xform3 c_th3s_findfixbin
        findFirstBinAbove = xform2 c_th3s_findfirstbinabove
        findLastBinAbove = xform2 c_th3s_findlastbinabove
        fit = xform5 c_th3s_fit
        fitPanelTH1 = xform0 c_th3s_fitpanelth1
        getNdivisionA = xform1 c_th3s_getndivisiona
        getAxisColorA = xform1 c_th3s_getaxiscolora
        getLabelColorA = xform1 c_th3s_getlabelcolora
        getLabelFontA = xform1 c_th3s_getlabelfonta
        getLabelOffsetA = xform1 c_th3s_getlabeloffseta
        getLabelSizeA = xform1 c_th3s_getlabelsizea
        getTitleFontA = xform1 c_th3s_gettitlefonta
        getTitleOffsetA = xform1 c_th3s_gettitleoffseta
        getTitleSizeA = xform1 c_th3s_gettitlesizea
        getTickLengthA = xform1 c_th3s_getticklengtha
        getBarOffset = xform0 c_th3s_getbaroffset
        getBarWidth = xform0 c_th3s_getbarwidth
        getContour = xform1 c_th3s_getcontour
        getContourLevel = xform1 c_th3s_getcontourlevel
        getContourLevelPad = xform1 c_th3s_getcontourlevelpad
        getBin = xform3 c_th3s_getbin
        getBinCenter = xform1 c_th3s_getbincenter
        getBinContent1 = xform1 c_th3s_getbincontent1
        getBinContent2 = xform2 c_th3s_getbincontent2
        getBinContent3 = xform3 c_th3s_getbincontent3
        getBinError1 = xform1 c_th3s_getbinerror1
        getBinError2 = xform2 c_th3s_getbinerror2
        getBinError3 = xform3 c_th3s_getbinerror3
        getBinLowEdge = xform1 c_th3s_getbinlowedge
        getBinWidth = xform1 c_th3s_getbinwidth
        getCellContent = xform2 c_th3s_getcellcontent
        getCellError = xform2 c_th3s_getcellerror
        getEntries = xform0 c_th3s_getentries
        getEffectiveEntries = xform0 c_th3s_geteffectiveentries
        getFunction = xform1 c_th3s_getfunction
        getDimension = xform0 c_th3s_getdimension
        getKurtosis = xform1 c_th3s_getkurtosis
        getLowEdge = xform1 c_th3s_getlowedge
        getMaximumTH1 = xform1 c_th3s_getmaximumth1
        getMaximumBin = xform0 c_th3s_getmaximumbin
        getMaximumStored = xform0 c_th3s_getmaximumstored
        getMinimumTH1 = xform1 c_th3s_getminimumth1
        getMinimumBin = xform0 c_th3s_getminimumbin
        getMinimumStored = xform0 c_th3s_getminimumstored
        getMean = xform1 c_th3s_getmean
        getMeanError = xform1 c_th3s_getmeanerror
        getNbinsX = xform0 c_th3s_getnbinsx
        getNbinsY = xform0 c_th3s_getnbinsy
        getNbinsZ = xform0 c_th3s_getnbinsz
        getQuantilesTH1 = xform3 c_th3s_getquantilesth1
        getRandom = xform0 c_th3s_getrandom
        getStats = xform1 c_th3s_getstats
        getSumOfWeights = xform0 c_th3s_getsumofweights
        getSumw2 = xform0 c_th3s_getsumw2
        getSumw2N = xform0 c_th3s_getsumw2n
        getRMS = xform1 c_th3s_getrms
        getRMSError = xform1 c_th3s_getrmserror
        getSkewness = xform1 c_th3s_getskewness
        integral1 = xform3 c_th3s_integral1
        interpolate1 = xform1 c_th3s_interpolate1
        interpolate2 = xform2 c_th3s_interpolate2
        interpolate3 = xform3 c_th3s_interpolate3
        kolmogorovTest = xform2 c_th3s_kolmogorovtest
        labelsDeflate = xform1 c_th3s_labelsdeflate
        labelsInflate = xform1 c_th3s_labelsinflate
        labelsOption = xform2 c_th3s_labelsoption
        multiflyF = xform2 c_th3s_multiflyf
        multiply = xform5 c_th3s_multiply
        putStats = xform1 c_th3s_putstats
        rebin = xform3 c_th3s_rebin
        rebinAxis = xform2 c_th3s_rebinaxis
        rebuild = xform1 c_th3s_rebuild
        recursiveRemove = xform1 c_th3s_recursiveremove
        reset = xform1 c_th3s_reset
        resetStats = xform0 c_th3s_resetstats
        scale = xform2 c_th3s_scale
        setAxisColorA = xform2 c_th3s_setaxiscolora
        setAxisRange = xform3 c_th3s_setaxisrange
        setBarOffset = xform1 c_th3s_setbaroffset
        setBarWidth = xform1 c_th3s_setbarwidth
        setBinContent1 = xform2 c_th3s_setbincontent1
        setBinContent2 = xform3 c_th3s_setbincontent2
        setBinContent3 = xform4 c_th3s_setbincontent3
        setBinError1 = xform2 c_th3s_setbinerror1
        setBinError2 = xform3 c_th3s_setbinerror2
        setBinError3 = xform4 c_th3s_setbinerror3
        setBins1 = xform2 c_th3s_setbins1
        setBins2 = xform4 c_th3s_setbins2
        setBins3 = xform6 c_th3s_setbins3
        setBinsLength = xform1 c_th3s_setbinslength
        setBuffer = xform2 c_th3s_setbuffer
        setCellContent = xform3 c_th3s_setcellcontent
        setContent = xform1 c_th3s_setcontent
        setContour = xform2 c_th3s_setcontour
        setContourLevel = xform2 c_th3s_setcontourlevel
        setDirectory = xform1 c_th3s_setdirectory
        setEntries = xform1 c_th3s_setentries
        setError = xform1 c_th3s_seterror
        setLabelColorA = xform2 c_th3s_setlabelcolora
        setLabelSizeA = xform2 c_th3s_setlabelsizea
        setLabelFontA = xform2 c_th3s_setlabelfonta
        setLabelOffsetA = xform2 c_th3s_setlabeloffseta
        setMaximum = xform1 c_th3s_setmaximum
        setMinimum = xform1 c_th3s_setminimum
        setNormFactor = xform1 c_th3s_setnormfactor
        setStats = xform1 c_th3s_setstats
        setOption = xform1 c_th3s_setoption
        setXTitle = xform1 c_th3s_setxtitle
        setYTitle = xform1 c_th3s_setytitle
        setZTitle = xform1 c_th3s_setztitle
        showBackground = xform2 c_th3s_showbackground
        showPeaks = xform3 c_th3s_showpeaks
        smooth = xform2 c_th3s_smooth
        sumw2 = xform0 c_th3s_sumw2

instance ITAtt3D TH3S

instance ITNamed TH3S where
        setName = xform1 c_th3s_setname
        setNameTitle = xform2 c_th3s_setnametitle
        setTitle = xform1 c_th3s_settitle

instance ITAttLine TH3S where
        getLineColor = xform0 c_th3s_getlinecolor
        getLineStyle = xform0 c_th3s_getlinestyle
        getLineWidth = xform0 c_th3s_getlinewidth
        resetAttLine = xform1 c_th3s_resetattline
        setLineAttributes = xform0 c_th3s_setlineattributes
        setLineColor = xform1 c_th3s_setlinecolor
        setLineStyle = xform1 c_th3s_setlinestyle
        setLineWidth = xform1 c_th3s_setlinewidth

instance ITAttFill TH3S where
        setFillColor = xform1 c_th3s_setfillcolor
        setFillStyle = xform1 c_th3s_setfillstyle

instance ITAttMarker TH3S where
        getMarkerColor = xform0 c_th3s_getmarkercolor
        getMarkerStyle = xform0 c_th3s_getmarkerstyle
        getMarkerSize = xform0 c_th3s_getmarkersize
        resetAttMarker = xform1 c_th3s_resetattmarker
        setMarkerAttributes = xform0 c_th3s_setmarkerattributes
        setMarkerColor = xform1 c_th3s_setmarkercolor
        setMarkerStyle = xform1 c_th3s_setmarkerstyle
        setMarkerSize = xform1 c_th3s_setmarkersize

instance ITObject TH3S where
        draw = xform1 c_th3s_draw
        findObject = xform1 c_th3s_findobject
        getName = xform0 c_th3s_getname
        isA = xform0 c_th3s_isa
        paint = xform1 c_th3s_paint
        printObj = xform1 c_th3s_printobj
        saveAs = xform2 c_th3s_saveas
        write = xform3 c_th3s_write

instance IDeletable TH3S where
        delete = xform0 c_th3s_delete

instance ITArray TH3S
